# -*- coding: utf-8 -*-
import sqlite3
import time
from PyQt4 import QtCore, QtGui, Qt
from PyQt4.QtGui import *
from PyQt4.QtSql import QSqlQueryModel,QSqlDatabase,QSqlQuery

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)


class MySqlModel(QSqlQueryModel):
    def data(self, index, role=Qt.Qt.DisplayRole):
        if role == Qt.Qt.TextAlignmentRole:
            return Qt.Qt.AlignCenter
        return QSqlQueryModel.data(self, index, role)

class ConectorBD():

    def __init__(self, base='BaseDatos/BaseDatosAplicacion.db'):
        self.base = base

    def conectarBD(self):
        try:
            self.con = sqlite3.connect(self.base)
            self.cursor = self.con.cursor()
            self.cursor.execute('PRAGMA foreign_keys=ON;')
            self.cursor.execute('PRAGMA enconding= "UTF-8";')
            return True
        except sqlite3.Error, e:
            print("Error: %s" % e.args[0])
            return False

    def desconectarBD(self):
        self.con.close()

    def login(self, user, passw):
        r = self.conectarBD()
        if r:
            self.cursor.execute(
                "select log_userName,log_password from Login where log_userName = '" + user + "' and log_password='" + passw + "'")
            data = self.cursor.fetchall()
            if (len(data) < 1):
                return False
            #self.desconectarBD()
            return (data[0][0] == user and data[0][1] == passw)
        print "No se puede conectar BD."
        return False

    def ejecutarQuery(self, query):
        r = self.conectarBD()
        if r:
            self.cursor.execute(query)
            data = self.cursor.fetchall()
            #self.desconectarBD()
            return data
        else:
            print "No se puede conectar a la BD"
            return None

    def obtenerUsuarios(self):
        r = self.conectarBD()
        if r:
            self.cursor.execute("SELECT log_username FROM Login")
            data = self.cursor.fetchall()
            self.desconectarBD()
            return data
        else:
            print "No se puede conectar a la BD"
            return None

    def obtenerDatosLog(self, Usuario, Clave):
        r = self.conectarBD()
        if r:
            self.cursor.execute("SELECT usr_pnombre, usr_apellidop, usr_rol, usr_foto, usr_id FROM Login INNER JOIN Usuario ON "
                                "Usuario.usr_id=Login.Usuario_usr_id  WHERE log_username = '"
                                + Usuario + "' and log_password = '" + Clave + "'")
            data = self.cursor.fetchone()
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return None

    def obtenerDatosUsuario(self, usuarioId):
        r = self.conectarBD()
        if r:
            query = 'SELECT * FROM Usuario INNER JOIN Login ON Usuario.usr_id=Login.Usuario_usr_id  WHERE ' \
                    'usr_id="' + str(usuarioId) + '" '
            self.cursor.execute(query)
            data = self.cursor.fetchone()
            return data
            self.desconectarBD
        else:
            print "No se puede conectar a la BD"
            return None

    def obtenerDatosPaciente(self, pacienteId):
        r = self.conectarBD()
        if r:
            query = 'SELECT * FROM Paciente WHERE pac_id = ' + str(pacienteId) + ' '
            self.cursor.execute(query)
            data = self.cursor.fetchone()
            return data
            self.desconectarBD
        else:
            print "No se puede conectar a la BD"
            return None


    def guardarDatosPaciente(self, pnombre, snombre, apellidop, apellidom, edadCron, edadLeng, sexo, diagMed, diagLeng, foto):
        r = self.conectarBD()
        if r:
            query = 'SELECT * FROM Paciente WHERE pac_pnombre = "' + str(pnombre) + '" AND pac_snombre="' \
                    + str(snombre) + '" AND pac_apellidop="' + str(apellidop) + '" AND pac_apellidom="' \
                    + str(apellidom) + '"'
            self.cursor.execute(query)
            dataR = self.cursor.fetchall()
            if (len(dataR) > 0):
                return False
            else:
                binary = sqlite3.Binary(foto)
                query = "INSERT INTO Paciente (pac_pnombre, pac_snombre, pac_apellidop, pac_apellidom, " \
                        "pac_edad_cron, pac_edad_leng, pac_sexo, pac_diag_med, pac_diag_leng, pac_foto) " \
                        "VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
                self.cursor.execute(query, (str(pnombre), str(snombre), str(apellidop), str(apellidom),
                                            edadCron, edadLeng, str(sexo), str(diagMed), str(diagLeng), binary))
                self.con.commit()
                return True
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def modificarDatosPaciente(self, PacId, pnombre, snombre, apellidop, apellidom, edadCron, edadLeng, sexo,
                               diagMed, diagLeng, foto):
        hacer = False
        r = self.conectarBD()
        if r:
            query = 'SELECT pac_pnombre, pac_snombre, pac_apellidop, pac_apellidom FROM Paciente ' \
                    'WHERE pac_id = "' + str(PacId) + '"'
            self.cursor.execute(query)
            dataR = self.cursor.fetchone()
            if dataR[0] != pnombre and dataR[1] != snombre and dataR[2] != apellidop and dataR[3] != apellidom:
                query = 'SELECT * FROM Paciente WHERE pac_pnombre = "' + str(pnombre) + '" AND pac_snombre="' \
                    + str(snombre) + '" AND pac_apellidop="' + str(apellidop) + '" AND pac_apellidom="' \
                    + str(apellidom) + '"'
                self.cursor.execute(query)
                dataR = self.cursor.fetchall()
                if (len(dataR) > 0):
                    hacer = False
                else:
                    hacer = True
            else:
                hacer = True
            if hacer:
                binary = sqlite3.Binary(foto)
                query = 'UPDATE Paciente ' \
                        'SET pac_pnombre=?, pac_snombre=?, pac_apellidop=?, pac_apellidom=?, pac_edad_cron=?,' \
                        ' pac_edad_leng=?, pac_sexo=?, pac_diag_med=?, pac_diag_leng=?, pac_foto=? WHERE pac_id = ?'
                self.cursor.execute(query, (str(pnombre), str(snombre), str(apellidop), str(apellidom), str(edadCron),
                                            str(edadLeng), str(sexo), str(diagMed), str(diagLeng), binary, str(PacId)))
                self.con.commit()
                return True
            else:
                return False
            self.desconectarBD
        else:
            print "No se puede conectar a la BD"
            return False


    def guardarDatosUsuario(self, pnombre, snombre, apellidop, apellidom, areaE, areaT, username, passw, rol, foto):
        r = self.conectarBD()
        if r:
            self.cursor.execute('SELECT log_userName FROM Login WHERE log_userName = "' + str(username) + '"')
            data = self.cursor.fetchall()
            if (len(data) > 0):
                return False
            else:
                binary = sqlite3.Binary(foto)
                query = "INSERT INTO Usuario (usr_pnombre, usr_snombre, usr_apellidop, usr_apellidom, usr_rol, " \
                        "usr_areaE, usr_areaT, usr_foto) VALUES(?, ?, ?, ?, ?, ?, ?, ?)"
                self.cursor.execute(query, (str(pnombre), str(snombre), str(apellidop), str(apellidom), str(rol),
                                            str(areaE), str(areaT), binary))
                lid = self.cursor.lastrowid
                query = 'INSERT INTO Login (log_userName, log_password, Usuario_usr_id) VALUES(?, ?, ?)'
                self.cursor.execute(query, (str(username), str(passw), str(lid)))
                self.con.commit()
                return True
            #self.desconectarBD()

        else:
            print "No se puede conectar a la BD"
            return False

    def modificarDatosUsuario(self, UserId, pnombre, snombre, apellidop, apellidom, areaE, areaT, username, passw, rol, foto):
        hacer = False
        r = self.conectarBD()
        if r:
            self.cursor.execute('SELECT log_userName FROM Login WHERE Usuario_usr_id = "' + str(UserId) + '"')
            data = self.cursor.fetchone()[0]
            if data != username:
                self.cursor.execute('SELECT log_userName FROM Login WHERE log_userName = "' + str(username) + '"')
                data = self.cursor.fetchall()
                if (len(data) > 0):
                    hacer = False
                else:
                    hacer = True
            else:
                hacer = True
            if hacer:
                binary = sqlite3.Binary(foto)
                query = 'UPDATE Usuario ' \
                        'SET usr_pnombre=?, usr_snombre=?, usr_apellidop=?, usr_apellidom=?, usr_areaE=?,' \
                        ' usr_areaT=?, usr_rol=?, usr_foto=? WHERE usr_id = ?'
                self.cursor.execute(query, (str(pnombre), str(snombre), str(apellidop), str(apellidom), str(areaE),
                                            str(areaT), str(rol), binary, UserId))
                query = 'UPDATE Login ' \
                        'SET log_userName=?, log_password=? WHERE Usuario_usr_id = ?'
                self.cursor.execute(query, (str(username), str(passw), UserId))
                self.con.commit()
                return True
            else:
                return False
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def cargarUser(self, tipoUser, numTbl, letras, ventana):
        db = QSqlDatabase("QSQLITE")
        db.setDatabaseName(self.base)
        db.open()
        modelo = MySqlModel()
        proxy = QSortFilterProxyModel()
        l1 = letras[0]
        l2 = letras[1]
        l3 = 'Ñ' if letras[2] == ';' else letras[2]
        l4 = letras[3]
        if tipoUser == "Usuarios":
            query = 'SELECT usr_id, usr_apellidop AS "Apellido", usr_pnombre AS "Nombre", usr_rol AS "Rol", log_userName AS "Usuario" FROM Login INNER JOIN' \
                    ' Usuario ON Usuario.usr_id=Login.Usuario_usr_id WHERE usr_apellidop like "' + l1 +\
                    '%" OR usr_apellidop like "' + l2 + '%" OR usr_apellidop like "' + l3 + '%" OR usr_apellidop like "' \
                    + l4 + '%" ORDER BY usr_apellidop ASC;'
        elif tipoUser == "Pacientes":
            query = 'SELECT pac_id, pac_apellidop || " " || pac_apellidom AS "Apellidos", pac_pnombre || " " || pac_snombre AS "Nombres",' \
                    'pac_edad_leng/12 AS "A L", pac_edad_leng%12 AS "M L" FROM ' \
                    'Paciente WHERE pac_apellidop like "' + l1 + '%" OR pac_apellidop like "' + l2 + '%" ' \
                    'OR pac_apellidop like "' + l3 + '%" OR pac_apellidop like "' + l4 + '%" ORDER BY ' \
                    'pac_apellidop ASC;'
        elif tipoUser == "Ejercicios":
            query = 'SELECT ejer_id, ejer_nombre AS "Ejercicio", ejer_categoria AS "Categoria",' \
                    'ejer_subcategoria AS "Subcategoria" FROM ' \
                    'Ejercicio WHERE ejer_nombre like "' + l1 + '%" OR ejer_nombre like "' + l2 + '%" ' \
                    'OR ejer_nombre like "' + l3 + '%" OR ejer_nombre like "' + l4 + '%" ORDER BY ' \
                    'ejer_nombre ASC;'
        modelo.setQuery(query, db)
        proxy.setSourceModel(modelo)
        codigo = 'ventana.tbl_' + str(numTbl) + '.setSortingEnabled(True)'
        eval(codigo)
        codigo = 'ventana.tbl_' + str(numTbl) + '.setModel(proxy)'
        eval(codigo)
        #codigo = 'ventana.tbl_' + str(numTbl) + '.horizontalHeader().setResizeMode(QtGui.QHeaderView.Stretch)'
        codigo = 'ventana.tbl_' + str(numTbl) + '.horizontalHeader().setResizeMode(QtGui.QHeaderView.ResizeToContents)'
        eval(codigo)
        codigo = 'ventana.tbl_' + str(numTbl) + '.verticalHeader().setResizeMode(QtGui.QHeaderView.ResizeToContents)'
        #codigo = 'ventana.tbl_' + str(numTbl) + '.verticalHeader().setResizeMode(QtGui.QHeaderView.Fixed)'
        eval(codigo)
        #codigo = 'ventana.tbl_' + str(numTbl) + '.verticalHeader().setDefaultSectionSize(60)'
        #eval(codigo)
        codigo = 'ventana.tbl_' + str(numTbl) + '.hideColumn(0)'
        eval(codigo)

    def cargarRegistros(self, hint, filtro, desde, hasta):
        db = QSqlDatabase("QSQLITE")
        db.setDatabaseName(self.base)
        db.open()
        modelo = MySqlModel()
        proxy = QSortFilterProxyModel()
        if hint == '':
            query = 'SELECT ejer_ses_id ,Sesion_ses_id AS "Sesion", ses_fecha AS "Fecha", pac_pnombre || " " || pac_apellidop AS "Paciente", usr_pnombre ' \
                    '|| " " || usr_apellidop AS "Terapista", ejer_nombre AS "Ejercicio", ejer_ses_puntuacion as ' \
                    '"Puntuacion" FROM Ejercicio_Sesion a JOIN Sesion e ON a.Sesion_ses_id=e.ses_id JOIN Paciente b ON a.Sesion_Paciente_pac_id=b.pac_id JOIN ' \
                    'Usuario c ON a.Sesion_Usuario_usr_id=c.usr_id JOIN Ejercicio d ON a.Ejercicio_ejer_id=d.ejer_id ' \
                    'WHERE ses_fecha BETWEEN "' + desde + '" AND "' + hasta + '"'
        else:
            if filtro == "Nombre de Paciente":
                campo = 'pac_pnombre'
            elif filtro == "Apellido de Paciente":
                campo = 'pac_apellidop'
            elif filtro == "Nombre de Terapista":
                campo = 'usr_pnombre'
            elif filtro == "Apellido de Terapista":
                campo = 'usr_apellidop'
            else:
                campo = 'ejer_nombre'
            query = 'SELECT ejer_ses_id ,Sesion_ses_id AS "Sesion", ses_fecha AS "Fecha", pac_pnombre || " " || pac_apellidop AS "Paciente", usr_pnombre ' \
                    '|| " " || usr_apellidop AS "Terapista", ejer_nombre AS "Ejercicio", ejer_ses_puntuacion as ' \
                    '"Puntuacion" FROM Ejercicio_Sesion a JOIN Sesion e ON a.Sesion_ses_id=e.ses_id JOIN Paciente b ON a.Sesion_Paciente_pac_id=b.pac_id JOIN ' \
                    'Usuario c ON a.Sesion_Usuario_usr_id=c.usr_id JOIN Ejercicio d ON a.Ejercicio_ejer_id=d.ejer_id ' \
                    'WHERE ses_fecha BETWEEN "' + desde + '" AND "' + hasta + '" AND ' + campo + ' LIKE "' + hint + '%"'
        modelo.setQuery(query, db)
        proxy.setSourceModel(modelo)
        return proxy

    def cargarDetalles(self, regId):
        db = QSqlDatabase("QSQLITE")
        db.setDatabaseName(self.base)
        db.open()
        modelo = MySqlModel()
        proxy = QSortFilterProxyModel()
        query = 'SELECT a.fal_id, b.dic_Palabra as "La palabra:", c.dic_Palabra as "la confunde con:" FROM Falla a ' \
                'JOIN Diccionario b ON a.palabra_correcta_id = b.dic_id JOIN Diccionario c ON ' \
                'a.palabra_incorrecta_id = c.dic_id WHERE a.Ejercicio_Sesion_ejer_ses_id = ' + str(regId) + ''
        modelo.setQuery(query, db)
        proxy.setSourceModel(modelo)
        return proxy

    def hacerConsultaModelo(self, consulta):
        self.db = QSqlDatabase("QSQLITE")
        self.db.setDatabaseName(self.base)
        self.db.open()
        modelo = MySqlModel()
        modelo.setQuery(consulta, self.db)
        return modelo

    def crearSesion(self, userid, pacId):
        r = self.conectarBD()
        if r:
            query = "INSERT INTO Sesion (ses_fecha, ses_observaciones, Usuario_usr_id, Paciente_pac_id) VALUES(?, ?, ?, ?)"
            self.cursor.execute(query, (time.strftime("%Y-%m-%d"), None, userid, pacId))
            self.con.commit()
        else:
            print "No se puede conectar a la BD"
            return False

    def agregarObservacionesSesion(self, observaciones):
        r = self.conectarBD()
        if r:
            query = 'SELECT MAX(ses_id) FROM Sesion'
            self.cursor.execute(query)
            idSesion = self.cursor.fetchone()[0]
            query = "UPDATE Sesion SET ses_observaciones=? WHERE ses_id=?"
            self.cursor.execute(query, (str(observaciones).decode('utf-8'), idSesion))
            self.con.commit()
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def obtenerDatosRegistro(self, regId):
        r = self.conectarBD()
        if r:
            query = 'SELECT b.ejer_nombre, c.usr_pnombre || " " || c.usr_apellidop,' \
                    ' d.pac_pnombre || " " || d.pac_apellidop, a.ejer_ses_puntuacion, a.ejer_ses_observacion, a.Sesion_ses_id, b.ejer_id, c.usr_id, d.pac_id, e.ses_observaciones ' \
                    'FROM Ejercicio_Sesion a JOIN Ejercicio b ON a.Ejercicio_ejer_id = b.ejer_id JOIN' \
                    ' Usuario c ON a.Sesion_Usuario_usr_id = c.usr_id JOIN Paciente d ON ' \
                    'a.Sesion_Paciente_pac_id = d.pac_id JOIN Sesion e ON a.Sesion_ses_id = e.ses_id WHERE ejer_ses_id = ' + str(regId) + ''
            self.cursor.execute(query)
            data = self.cursor.fetchall()[0]
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def obtenerNombreEjercicio(self, ejerId):
        r = self.conectarBD()
        if r:
            query = 'SELECT ejer_nombre FROM Ejercicio WHERE ejer_id = ' + str(ejerId) + ''
            self.cursor.execute(query)
            data = self.cursor.fetchone()[0]
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False


    def obtenerNombreUsuario(self, usrId):
        r = self.conectarBD()
        if r:
            query = 'SELECT usr_pnombre || " " || usr_apellidop, usr_rol FROM Usuario WHERE usr_id = ' + str(usrId) + ''
            self.cursor.execute(query)
            data = self.cursor.fetchone()
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def obtenerNombrePaciente(self, pacId):
        r = self.conectarBD()
        if r:
            query = 'SELECT pac_pnombre || " " || pac_apellidop FROM Paciente WHERE pac_id = ' + str(pacId) + ''
            self.cursor.execute(query)
            data = self.cursor.fetchone()[0]
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def obtenerEjercicios(self, subcategoria):
        r = self.conectarBD()
        if r:
            query = 'SELECT ejer_id, ejer_nombre FROM Ejercicio WHERE ejer_subcategoria = "' + str(subcategoria) + '" '
            self.cursor.execute(query)
            data = self.cursor.fetchall()
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def modificarRegistro(self, regId, sesId, ejerId, usrId, pacId, punt, observ, observSes):
        r = self.conectarBD()
        if r:
            query = 'UPDATE Sesion SET Usuario_usr_id=?, Paciente_pac_id=?, ses_observaciones=? WHERE ses_id = ?'
            self.cursor.execute(query, (str(usrId), str(pacId), str(observSes).decode('utf-8'), str(sesId)))
            query = 'UPDATE Ejercicio_Sesion SET Ejercicio_ejer_id=?, ejer_ses_puntuacion=?, ejer_ses_observacion=? ' \
                    'WHERE ejer_ses_id=?'
            self.cursor.execute(query, (str(ejerId), str(punt), str(observ).decode('utf-8'), str(regId)))
            self.con.commit()
            #self.desconectarBD()
            return True
        else:
            print "No se puede conectar a la BD"
            return False


    def obtenerNombreVentana(self, indexVentana):
        r = self.conectarBD()
        if r:
            query = "SELECT ejer_ventana FROM Ejercicio WHERE ejer_id = '" + str(indexVentana) + "'"
            self.cursor.execute(query)
            data = self.cursor.fetchone()[0]
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def obtenerDiccionario(self, dificultad):
        r = self.conectarBD()
        if r:
            query = 'SELECT dic_id, dic_Palabra, dic_Imagen, dic_sonido, dic_silabas, dic_categoria FROM diccionario' \
                    ' WHERE dic_dificultad = ' + str(dificultad) + ''
            self.cursor.execute(query)
            data = self.cursor.fetchall()
            return data
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False

    def guardarPuntuacion(self, idEjercicio, idUsuario, idPaciente, dificultad, puntuacion, regIntentos, observaciones):
        r = self.conectarBD()
        if r:
            query = 'SELECT MAX(ses_id) FROM Sesion'
            self.cursor.execute(query)
            idSesion = self.cursor.fetchone()[0]
            query = "INSERT INTO Ejercicio_Sesion (Ejercicio_ejer_id, Sesion_ses_id, Sesion_Usuario_usr_id, " \
                    "Sesion_Paciente_pac_id, ejer_ses_dificultad, ejer_ses_puntuacion, ejer_ses_observacion) VALUES (?, ?,?, ?, ?, ?, ?)"
            self.cursor.execute(query, (idEjercicio, idSesion, idUsuario, idPaciente, dificultad, puntuacion, str(observaciones).decode('utf-8')))
            query = 'SELECT MAX(ejer_ses_id) FROM Ejercicio_Sesion'
            self.cursor.execute(query)
            idEjerSes = self.cursor.fetchone()[0]
            datos = []
            for i in range(0, regIntentos.__len__()):
                datos.append((idEjerSes, regIntentos[i][0], regIntentos[i][1]))
            datost = tuple(datos)
            query = "INSERT INTO Falla (Ejercicio_Sesion_ejer_ses_id, palabra_correcta_id, palabra_incorrecta_id)" \
                    " VALUES (?, ?, ?)"
            self.cursor.executemany(query, datost)
            self.con.commit()
            #self.desconectarBD()
        else:
            print "No se puede conectar a la BD"
            return False



if __name__ == "__main__":
    conector = ConectorBD("BaseDatosAplicacion1.db")
    palabras = conector.obtenerDiccionario(1)
    print palabras

