CREATE TABLE sqlite_sequence(name,seq);
CREATE TABLE Usuario (
    usr_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    usr_pnombre TEXT NOT NULL,
    usr_snombre TEXT NOT NULL,
    usr_apellidop TEXT NOT NULL,
    usr_apellidom TEXT NOT NULL,
    usr_areaE TEXT,
    usr_areaT TEXT,
    usr_rol TEXT NOT NULL,
    usr_foto BLOB
);
CREATE TABLE Paciente (
    pac_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    pac_pnombre TEXT NOT NULL,
    pac_snombre TEXT NOT NULL,
    pac_apellidop TEXT NOT NULL,
    pac_apellidom TEXT NOT NULL,
    pac_edad_cron INTEGER NOT NULL,
    pac_edad_leng INTEGER,
    pac_sexo INTEGER NOT NULL,
    pac_diag_med TEXT,
    pac_diag_leng TEXT,
    pac_foto BLOB
);
CREATE TABLE Login (
    log_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    log_userName TEXT NOT NULL,
    log_password TEXT NOT NULL,
    Usuario_usr_id INTEGER NOT NULL,
    UNIQUE(Usuario_usr_id)
    FOREIGN KEY (Usuario_usr_id)
    REFERENCES Usuario(usr_id)
);
;
CREATE TABLE Diccionario (
    "dic_id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    "dic_Palabra" TEXT NOT NULL,
    "dic_Imagen" BLOB NOT NULL,
    "dic_silabas" INTEGER NOT NULL,
    "dic_sonido" BLOB,
    "dic_dificultad" INTEGER NOT NULL,
    "dic_categoria" TEXT
);
CREATE TABLE ejercicio (
    "ejer_id" INTEGER PRIMARY KEY NOT NULL,
    "ejer_categoria" TEXT NOT NULL,
    "ejer_subcategoria" TEXT NOT NULL,
    "ejer_nombre" TEXT NOT NULL,
    "ejer_descripcion" TEXT NOT NULL,
    "ejer_materiales" TEXT
, "ejer_ventana" TEXT);


CREATE TABLE Sesion (
    ses_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    ses_fecha TEXT NOT NULL,
    ses_observaciones TEXT,
    Usuario_usr_id INTEGER NOT NULL,
    Paciente_pac_id INTEGER NOT NULL,
    UNIQUE(ses_id,Usuario_usr_id,Paciente_pac_id),
    FOREIGN KEY (Usuario_usr_id)
    REFERENCES Usuario(usr_id)
    ON UPDATE CASCADE,
    FOREIGN KEY (Paciente_pac_id)
    REFERENCES Paciente(pac_id)
    ON UPDATE CASCADE
);
;
CREATE TABLE Ejercicio_Sesion (
    ejer_ses_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    Ejercicio_ejer_id INTEGER NOT NULL,
    Sesion_ses_id INTEGER NOT NULL,
    Sesion_Usuario_usr_id INTEGER NOT NULL,
    Sesion_Paciente_pac_id INTEGER NOT NULL,
    ejer_ses_dificultad INTEGER,
    ejer_ses_puntuacion INTEGER,
    ejer_ses_observacion TEXT,
    UNIQUE( ejer_ses_id, Ejercicio_ejer_id, Sesion_ses_id , Sesion_Usuario_usr_id , Sesion_Paciente_pac_id)
    FOREIGN KEY (Ejercicio_ejer_id)
    REFERENCES Ejercicio(ejer_id),
    FOREIGN KEY (Sesion_ses_id , Sesion_Usuario_usr_id , Sesion_Paciente_pac_id)
    REFERENCES Sesion (ses_id , Usuario_usr_id , Paciente_pac_id)
    ON UPDATE CASCADE
);
;
CREATE TABLE Intento (
    int_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    Ejercicio_Sesion_ejer_ses_id INTEGER NOT NULL,
    Diccionario_dic_id INTEGER NOT NULL,
    int_acierto BOOLEAN NOT NULL,
    UNIQUE( int_id,  Ejercicio_Sesion_ejer_ses_id, Diccionario_dic_id)
    FOREIGN KEY (Ejercicio_Sesion_ejer_ses_id)
    REFERENCES Ejercicio_Sesion(ejer_ses_id),
    FOREIGN KEY (Diccionario_dic_id)
    REFERENCES Diccionario(dic_id)
);
;
