import pigpio
import time

class Motores():
    
    def __init__(self):
        self.pi = pigpio.pi()
        self.pi.set_mode(18, pigpio.OUTPUT) #En la conexion es 12
        self.pi.set_mode(23, pigpio.OUTPUT) #En la conexion es 16
        self.pi.set_mode(24, pigpio.OUTPUT) #En la conexion es 18
        self.pi.set_mode(25, pigpio.OUTPUT) #En la conexion es 2  
        
        self.pi.set_PWM_frequency(20, 100)
        self.pi.set_PWM_frequency(16, 100)
        self.pi.set_PWM_frequency(12, 100)
        self.pi.set_mode(20, pigpio.OUTPUT) #En la conexion es 38
        self.pi.set_mode(16, pigpio.OUTPUT) #En la conexion es 36
        self.pi.set_mode(12, pigpio.OUTPUT) #En la conexion es 32

    def mapear(self, grados, iniciog, fing, iniciop, finp):
        if grados >= iniciog and grados <= fing:
            a = finp - iniciop
            b = fing - iniciog
            return grados*a/b + iniciop


    def arriba(self):
        self.pi.write(18, 0)
        self.pi.write(23, 1)
        self.pi.write(24, 0)
        self.pi.write(25, 1)

        
    def abajo(self):
        self.pi.write(18, 1)
        self.pi.write(23, 0)
        self.pi.write(24, 1)
        self.pi.write(25, 0)


    def izquierda(self):
        self.pi.write(18, 1)
        self.pi.write(23, 0)
        self.pi.write(24, 0)
        self.pi.write(25, 1)


    def derecha(self):
        self.pi.write(18, 0)
        self.pi.write(23, 1)
        self.pi.write(24, 1)
        self.pi.write(25, 0)


    def parar(self):
        self.pi.write(18, 0)
        self.pi.write(23, 0)
        self.pi.write(24, 0)
        self.pi.write(25, 0)

    def moverCabeza(self, grados):
        pwm = self.mapear(grados, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(16, pwm)

    def moverBrazoIzquierdo(self, grados):
        pwm = self.mapear(grados, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(20, pwm)

    def moverBrazoDerecho(self, grados):
        pwm = self.mapear(grados, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(12, pwm)

    def moverRuedaIzquierda(self):
        self.pi.write(18, 0)
        self.pi.write(23, 1)
        time.sleep(3)
        self.pi.write(18, 1)
        self.pi.write(23, 0)
        time.sleep(3)
        self.parar()

    def moverRuedaDerecha(self):
        self.pi.write(24, 0)
        self.pi.write(25, 1)
        time.sleep(3)
        self.pi.write(24, 1)
        self.pi.write(25, 0)
        time.sleep(3)
        self.parar()

    def moverBien(self):
        pwm = self.mapear(0, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(20, pwm)
        pwm = self.mapear(270, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(12, pwm)
        time.sleep(1)
        self.ponerNormal()


    def moverMal(self):
        pwm = self.mapear(270, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(20, pwm)
        pwm = self.mapear(0, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(12, pwm)
        pwm = self.mapear(65, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(16, pwm)
        time.sleep(0.5)
        pwm = self.mapear(200, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(16, pwm)
        time.sleep(1)
        self.ponerNormal()


    def ponerNormal(self):
        pwm = self.mapear(135, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(16, pwm)
        pwm = self.mapear(135, 0, 270, 15, 65)
        self.pi.set_PWM_dutycycle(20, pwm)
        self.pi.set_PWM_dutycycle(12, pwm)





if __name__ == '__main__':
    m = Motores()
    while True:
        m.parar()
        m.arriba()
        time.sleep(3)
        m.parar()
        m.abajo()
        time.sleep(3)
        m.parar()
        m.izquierda()
        time.sleep(3)
        m.parar()
        m.derecha()
        time.sleep(3)

