import sqlite3
from flask import Flask, render_template, Response, request
from contextlib import closing
#from CamaraUbuntu import *
from CamaraRaspberry import *
from tts import TTS
import motores3
import time


app = Flask(__name__)
app.config.from_object(__name__)

salir = 0
variable = 0
camara = None

mot = motores3.Motores()
leer = TTS()

@app.route('/')
def Index():
    pararCamara()
    return render_template("index.html")


@app.route('/movimiento.html')
def movimiento():
    pararCamara()
    return render_template("movimiento.html")

@app.route('/hablar.html')
def hablar():
    pararCamara()
    return render_template("hablar.html")

@app.route('/_habla')
def habla():
    texto = request.args.get('texto')
    leer.hablar(texto)
    return ""

@app.route('/_arriba')
def up():
    mot.arriba()
    return ""


@app.route('/_abajo')
def down():
    mot.abajo()
    return ""


@app.route('/_izquierda')
def left():
    mot.izquierda()
    return ""


@app.route('/_derecha')
def right():
    mot.derecha()
    return ""


@app.route('/_parar')
def parar():
    mot.parar()
    return ""

def pararCamara():
    global camara
    camara = None


@app.route('/camara.html')
def camara():
    return render_template('camara.html')


def gen():
    global camara
    detector = DeteccionFacial(cascade_fn="Servidor/haarcascade_frontalface_alt2.xml", minNeighbors=5, scaleFactor=1.1)
    #camara = Camara(0)
    camara = Camara()
    time.sleep(0.1)
    while True:
        captura = camara.capturarImagen()
        img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
        caras = detector.detectar(img)
        salida = detector.delimitar(img, caras)
        img1 = cv2.resize(salida, (salida.shape[1] * 2, salida.shape[0] * 2), interpolation=cv2.INTER_CUBIC)
        frame = camara.transmitir(img1)
        yield (b'--frame\r\n'b'Content-Type: image/jpeg\r\n\r\n' + frame + b'\r\n\r\n')

@app.route('/video_feed')
def video_feed():
    if salir == 0:
        return Response(gen(),
                        mimetype='multipart/x-mixed-replace; boundary=frame')


if __name__ == '__main__':
    app.run(host='0.0.0.0', threaded=True)
    pararCamara()
