# -*- coding: utf-8 -*-
import socket
import fcntl
import struct
import pygame
import subprocess, signal
import sys
import time
from PyQt4 import QtCore, QtGui
import threading
from PyQt4.QtGui import *
from AplicacionCodigo.Servidor.tts import TTS
from autonomoControl import Ui_frm_AutonomoControl
from AplicacionCodigo.Ventanas.modoAutonomo1 import modoAutonomo


reload(sys)
sys.setdefaultencoding("utf-8")


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaAutonomoControl(QtGui.QWidget):

    def __init__(self, modo):
        super(VentanaAutonomoControl, self).__init__()
        self.modo = modo
        self.leer = TTS()
        self.ui = Ui_frm_AutonomoControl()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.leer = TTS()

    def get_ip_address(self, ifname):
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        return socket.inet_ntoa(fcntl.ioctl(
            s.fileno(),
            0x8915,  # SIOCGIFADDR
            struct.pack('256s', ifname[:15])
        )[20:24])

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_modoAutonomo.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_iniciarTerminar.setStyleSheet("background-color: rgb(153, 255, 102)")

    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_iniciarTerminar.clicked.connect(self.iniciarModoAutonomo)


    def iniciarModoAutonomo(self):
        if self.ui.btn_iniciarTerminar.text() == 'Iniciar':
            self.ui.btn_iniciarTerminar.setText('Terminar')
            if self.modo == 'control':
                self.abrirServidor()
            else:
                self.hilo = threading.Thread(target=self.modoAutonomo, name="hilo")
                self.hilo.start()
        elif self.ui.btn_iniciarTerminar.text() == 'Terminar':
            if self.modo == 'control':
                self.ui.btn_iniciarTerminar.setText('Iniciar')
                self.cerrarServidor()
            else:
                self.autonomo.paro = True
                QMessageBox.about(self, 'Alerta', 'Decir "Adios" para terminar el modo autonomo')



    def modoAutonomo(self):
        self.autonomo = modoAutonomo()
        self.autonomo.c.Back.connect(self.salirModoAutonomo)
        self.autonomo.c.Escribir.connect(self.escribirTexto)
        self.autonomo.iniciar()

    def escribirTexto(self):
        texto = self.autonomo.escribir
        self.ui.plainTextEdit.setPlainText(texto)


    def salirModoAutonomo(self):
        print 'Quiso salir'
        self.ui.btn_iniciarTerminar.setText('Iniciar')


    def guardarTexto(self, nombre, texto):
        try:
            fout = open('../AplicacionCodigo/Biblioteca/Imagenes/' +texto + '.text', 'wb')
            fout.write(nombre)
        except IOError, e:
            print "Error %d: %s" % (e.args[0], e.args[1])
            sys.exit(1)
        finally:
            if fout:
                fout.close()

    def reproducirAudio1(self,event):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/audio1.wav')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
         continue
        archivo = open('../AplicacionCodigo/Biblioteca/Imagenes/texto1.text','r')
        linea = archivo.readline()
        archivo.close()
        time.sleep(1)
        self.leer.hablar(linea)

    def clickSalir(self, event):
        if self.ui.btn_iniciarTerminar.text() == 'Terminar':
            QMessageBox.about(self, 'Alerta', 'Por favor, dar click en terminar\npara poder salir')
        if self.ui.btn_iniciarTerminar.text() == 'Iniciar':
            self.c.Back.emit()

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

    def abrirServidor(self):
         try:
            ip = self.get_ip_address('wlan0')
            self.proc = subprocess.Popen(['python', 'Servidor/servidorRaspberry.py'])
            print self.proc.pid
            QMessageBox.about(self, 'Alerta', 'Conectarse a ' + str(ip) + ':5000\npara poder acceder al control remoto')
            self.ui.plainTextEdit.setPlainText('Conectarse a ' + str(ip) + ':5000\npara poder acceder al control remoto')
         except IOError:
            QMessageBox.about(self, 'Alerta', 'No se ha conectado a ninguna red inalambrica')
    def cerrarServidor(self):
        self.proc.send_signal(signal.SIGINT)
        subprocess.check_output("lsof -i :5000 | grep 'python'| cut -d ' ' -f3 | xargs kill -9", shell=True)
        self.ui.plainTextEdit.setPlainText(' ')

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp =VentanaAutonomoControl()
    myapp.show()
    sys.exit(app.exec_())


