import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from baseDatos import Ui_frm_BaseDatos
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()


class VentanaBaseDatos(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaBaseDatos, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_BaseDatos()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.mI = VentanaMetodosIngreso()
        self.conector = ConectorBD()

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuSuperUE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_query.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.txt_sql.installEventFilter(self)

    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        self.ui.btn_query.clicked.connect(self.hacerConsulta)

    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
                self.ui.btn_query.setFocus(True)
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)

    def hacerConsulta(self):
        textoIngresado = self.ui.txt_sql.toPlainText()
        modelo = self.conector.hacerConsultaModelo(textoIngresado)
        self.ui.tbl_resultado.setModel(modelo)


    def clickAtras(self, event):
        self.c.Back.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaBaseDatos()
    myapp.show()
    sys.exit(app.exec_())


