import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from detallesRegistro import Ui_frm_detalesRegistro
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaDetallesRegistro(QtGui.QWidget):

    def __init__(self, Datos, regId):
        super(VentanaDetallesRegistro, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.regId = regId
        self.ui = Ui_frm_detalesRegistro()
        self.ui.setupUi(self)
        self.InfoUsr()
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.cargarVentana()
        self.c = Communicate()
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.tbl_salidaFiltro.horizontalHeader().setResizeMode(QtGui.QHeaderView.Stretch)
        self.ui.tbl_salidaFiltro.verticalHeader().setResizeMode(QtGui.QHeaderView.ResizeToContents)
        self.ui.tbl_salidaFiltro.setSortingEnabled(True)


    def cargarVentana(self):
        datos = self.conector.obtenerDatosRegistro(self.regId)
        self.ui.txt_Ejercicio.setText(datos[0])
        self.ui.txt_Terapista.setText(datos[1])
        self.ui.txt_Paciente.setText(datos[2])
        self.ui.txt_Puntuacion.setText(str(datos[3]))
        self.ui.txt_Observaciones.setPlainText(datos[4])
        if datos[9] is not None:
            self.ui.txt_Observaciones_Ses.setPlainText(datos[9])
        self.sesId = datos[5]
        self.ejerId = datos[6]
        self.userId = datos[7]
        self.pacId = datos[8]
        modelo = self.conector.cargarDetalles(self.regId)
        self.ui.tbl_salidaFiltro.setModel(modelo)
        self.ui.tbl_salidaFiltro.hideColumn(0)



    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_registrosE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras


    def clickAtras(self, event):
        self.c.Back.emit()

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaDetallesRegistro()
    myapp.show()
    sys.exit(app.exec_())


