# -*- coding: utf-8 -*-

import pygame
import random
import sys
import time
import threading
from PyQt4 import QtCore, QtGui

from PyQt4.QtGui import *

from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD
from AplicacionCodigo.Servidor.tts import TTS
from AplicacionCodigo.Ventanas.VentanaPuntuacion import VentanaPuntuacion
from duracionAcustica import Ui_JuegoFonologica
from AplicacionCodigo.Servidor.motores3 import Motores

reload(sys)
sys.setdefaultencoding("utf-8")


try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()
    CargarDatos = QtCore.pyqtSignal()

class VentanaDuracionAcustica(QtGui.QWidget):

    def __init__(self, Datos, DatosPac, dificultad, idEjercicio):
        super(VentanaDuracionAcustica, self).__init__()
        self.leer = TTS()
        self.dificultad = dificultad
        self.datos = Datos
        self.datosPac=DatosPac
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.idEjercicio = idEjercicio
        self.contadorIntentos = 0
        self.contadorPaginas = 0
        self.puntuacion = 0
        self.ui = Ui_JuegoFonologica()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.InfoPac()
        self.modificarBotones()
        self.c = Communicate()
        self.conexiones()
        self.conector = ConectorBD()
        self.diccionario = self.conector.obtenerDiccionario(self.dificultad)
        self.palabrasUsadas = []
        self.registroIntentos = []
        self.ocupado = False
        self.m = Motores()
        self.cargarDatos()



    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_duracionAcustica.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Opcion1.setStyleSheet("background-color: rgb(204, 255, 204)")
        self.ui.btn_Opcion2.setStyleSheet("background-color: rgb(204, 255, 204)")
        self.ui.btn_Opcion1.installEventFilter(self)
        self.ui.btn_Opcion2.installEventFilter(self)

    def cargarDatos(self):
        self.contadorPaginas = self.contadorPaginas + 1
        if self.contadorPaginas <= 5:
            dim = self.diccionario.__len__()
            while True:
                r1 = random.randint(0, dim-1)
                if not self.estaRepetido(self.diccionario[r1][0]):
                    break
            self.ui.lbl_descImag1.setText(self.diccionario[r1][1])
            self.guardarImagen(self.diccionario[r1][2])
            self.ui.btnl_Imag1.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Biblioteca/Imagenes/imagen.jpg"))
            self.guardarAudio(self.diccionario[r1][3], 'audio1')
            while True:
                r2 = random.randint(0, dim-1)
                if r2 != r1 and self.diccionario[r1][4] != self.diccionario[r2][4]:
                    if not self.estaRepetido(self.diccionario[r2][0]):
                        break
            self.ui.lbl_descImag2.setText(self.diccionario[r2][1])
            self.guardarImagen(self.diccionario[r2][2])
            self.ui.btnl_Imag2.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Biblioteca/Imagenes/imagen.jpg"))
            self.guardarAudio(self.diccionario[r2][3], 'audio2')
            if self.diccionario[r1][4] > self.diccionario[r2][4]:
                self.ui.btnl_Imag1.mousePressEvent = self.opcionCorrecta
                self.ui.btnl_Imag2.mousePressEvent = self.opcionIncorrecta
                palabraCorrecta = self.diccionario[r1][0]
                palabraIncorrecta = self.diccionario[r2][0]
            else:
                self.ui.btnl_Imag1.mousePressEvent = self.opcionIncorrecta
                self.ui.btnl_Imag2.mousePressEvent = self.opcionCorrecta
                palabraCorrecta = self.diccionario[r2][0]
                palabraIncorrecta = self.diccionario[r1][0]
            self.palabrasUsadas.append((palabraCorrecta, palabraIncorrecta))

        else:
            if self.puntuacion < 1:
                self.puntuacion = 0
            elif self.puntuacion > 10:
                self.puntuacion = 10
            self.ventanaAbierta = 'punt'
            self.punt = VentanaPuntuacion(self.datos, self.datosPac, self.puntuacion, self.idEjercicio,
                                          self.registroIntentos, self.dificultad)
            self.punt.show()
            self.close()
            self.audioPuntuacion()
            self.punt.c.Back.connect(self.clickSalirPuntuacion)

    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btnl_Imag1.mousePressEvent = self.opcionCorrecta
        self.ui.btnl_Imag2.mousePressEvent = self.opcionIncorrecta
        self.c.CargarDatos.connect(self.cargarDatos)

    def eventFilter(self, QObject, QEvent):
        if QEvent.type() == QtCore.QEvent.MouseButtonRelease:
            if not self.ocupado:
                if QObject is self.ui.btn_Opcion1:
                    a = threading.Thread(target=self.reproducirAudio1)
                    a.start()
                elif QObject is self.ui.btn_Opcion2:
                    a = threading.Thread(target=self.reproducirAudio2)
                    a.start()
            else:
                QEvent.ignore()
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)


    def estaRepetido(self, palabra):
        repetido = False
        dimension = self.palabrasUsadas.__len__()
        for p in self.palabrasUsadas:
            if palabra == p[0] or palabra == p[1]:
                repetido = True
                break
            else:
                repetido = False
        return repetido


    def opcionCorrecta(self, event):
        if not self.ocupado:
            a = threading.Thread(target=self.hiloOpcionCorrecta)
            a.start()
        else:
            event.ignore()

    def hiloOpcionCorrecta(self):
        self.ocupado = True
        self.audioOpcionCorrecta()
        self.contadorIntentos = 0
        self.puntuacion = self.puntuacion + 2
        self.c.CargarDatos.emit()
        self.ocupado = False

    def opcionIncorrecta(self, event):
        if not self.ocupado:
            a = threading.Thread(target=self.hiloOpcionIncorrecta)
            a.start()
        else:
            event.ignore()


    def hiloOpcionIncorrecta(self):
        self.ocupado = True
        self.contadorIntentos = self.contadorIntentos + 1
        if self.contadorIntentos == 4:
            self.contadorIntentos = 0
            self.c.CargarDatos.emit()
        self.audioOpcionIncorrecta()
        self.puntuacion = self.puntuacion - 1
        self.registrarIntento()
        self.ocupado = False


    def guardarImagen(self, imagen):
        try:
            fout = open('../AplicacionCodigo/Biblioteca/Imagenes/imagen.jpg', 'wb')
            fout.write(imagen)
        except IOError, e:
            print "Error %d: %s" % (e.args[0], e.args[1])
            sys.exit(1)
        finally:
            if fout:
                fout.close()

    def guardarAudio(self, audio, nombre):
        if audio != None:
            try:
                fout = open('../AplicacionCodigo/Biblioteca/AUDIO/' + nombre + '.mp3','wb')
                fout.write(audio)
                fout.close()

            except IOError, e:
                print "Error %d: %s" % (e.args[0], e.args[1])
                sys.exit(1)

    def reproducirAudio1(self):
        self.ocupado = True
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/audio1.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
            continue
        self.ocupado = False



    def reproducirAudio2(self):
        self.ocupado = True
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/audio2.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
            continue
        self.ocupado = False

    def audioOpcionCorrecta(self):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/bien.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
            #continue
            self.m.moverBien()


    def audioOpcionIncorrecta(self):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/intentaloDeNuevo.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
            #continue
            self.m.moverMal()


    def registrarIntento(self):
        palabra = self.palabrasUsadas[self.palabrasUsadas.__len__()-1]
        self.registroIntentos.append((palabra[0], palabra[1]))


    def audioPuntuacion(self):
        pygame.mixer.init()
        if self.puntuacion >= 10:
            pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/excelente.mp3')
        elif 5 <= self.puntuacion < 10:
            pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/muyBien.mp3')
        elif 0 <= self.puntuacion < 5:
            pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/OooOoo.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
             continue


    def clickSalir(self, event):
        mensaje = _translate('Ejercicio',"Está seguro que desea salir?\nNo se guardará el progreso", None )
        result = QMessageBox.question(self, 'Pregunta', mensaje, QMessageBox.Yes | QMessageBox.No, QMessageBox.No)
        if result == QMessageBox.Yes:
            self.c.Back.emit()

    def clickSalirPuntuacion(self):
        eval('self.' + self.ventanaAbierta + '.close()')
        self.c.Back.emit()

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp =VentanaDuracionAcustica()
    myapp.show()
    sys.exit(app.exec_())


