# -*- coding: utf-8 -*-
import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from elegirEjercicio import Ui_frm_ElegirEjercicio
from AplicacionCodigo.BaseDatos.ConectorBD import *
from AplicacionCodigo.Ventanas.VentanaDificultad import VentanaDificultad
from AplicacionCodigo.Ventanas.VentanaDuracionAcustica import VentanaDuracionAcustica
from AplicacionCodigo.Ventanas.VentanaReconocimientoCategorias import VentanaReconocimientoCategorias
from AplicacionCodigo.Ventanas.VentanaDiscriminacionSemantica import VentanaDiscriminacionSemantica

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaElegirEjercicio(QtGui.QWidget):

    def __init__(self, Datos, DatosPac, Subcategoria, subcat, cat):
        super(VentanaElegirEjercicio, self).__init__()
        self.datos = Datos
        self.datosPac = DatosPac
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.categoria = cat
        self.subcategoria = subcat
        self.ui = Ui_frm_ElegirEjercicio()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.InfoUsr()
        self.InfoPac()
        self.conexiones()
        self.c = Communicate()
        self.conector = ConectorBD()


        datos = self.conector.obtenerEjercicios(Subcategoria)
        self.idEjercicios = [0]
        for ejercicio in datos:
            self.ui.cb_Ejercicios.addItem(ejercicio[1])
            self.idEjercicios.append(ejercicio[0])


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))


    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_elegirEjercicio.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Elegir.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.label_2.setText(self.subcategoria)
        self.ui.label.setText(_translate('Elegir Ejercicio', self.categoria, None))


    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_Elegir.clicked.connect(self.abrirVentana)

    def abrirVentana(self):
        if self.ui.cb_Ejercicios.currentIndex() > 0:
            self.ventanaAbierta = 'dificultad'
            self.dificultad = VentanaDificultad(self.datos, self.datosPac)
            self.dificultad.show()
            self.close()
            self.dificultad.c.Elegido.connect(self.dificultadElegida)
            self.dificultad.c.Back.connect(self.backMenu)

    def dificultadElegida(self):
        dificultad = self.dificultad.dificultad

        indexVentana = self.ui.cb_Ejercicios.currentIndex()
        idEjercicio = self.idEjercicios[indexVentana]
        nombreVentana = self.conector.obtenerNombreVentana(idEjercicio)
        self.ventanaEjercicio = eval(str(nombreVentana) + '(self.datos, self.datosPac, dificultad, idEjercicio)')
        self.ventanaEjercicio.show()
        eval('self.' + self.ventanaAbierta + '.close()')
        self.close()
        self.ventanaAbierta = 'ventanaEjercicio'
        self.ventanaEjercicio.c.Back.connect(self.backMenu)


    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

    def clickSalir(self, event):
        self.c.Back.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaElegirEjercicio()
    myapp.show()
    sys.exit(app.exec_())
