import sys
import time
import subprocess, signal, os
import socket
import fcntl
import struct
import thread
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from funcEspecificas import Ui_frm_funcionesEspecificas
from AplicacionCodigo.Ventanas.VentanaDeteccionFacial import VentanaDeteccionFacial
from AplicacionCodigo.Ventanas.VentanaMotores import VentanaMotores
from AplicacionCodigo.Ventanas.VentanaProbarTts import VentanaProbarTts
from AplicacionCodigo.Ventanas.VentanaProbarStt import VentanaPruebaStt
from AplicacionCodigo.Servidor.servidorRaspberry import *


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaFuncEspecificas(QtGui.QWidget, QtCore.QObject):

    def __init__(self, Datos):
        super(VentanaFuncEspecificas, self).__init__()
        self.Datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_funcionesEspecificas()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.servidor = app

    def get_ip_address(self, ifname):
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        return socket.inet_ntoa(fcntl.ioctl(
            s.fileno(),
            0x8915,  # SIOCGIFADDR
            struct.pack('256s', ifname[:15])
        )[20:24])

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuSuperUE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_TextoVoz.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_VozTexto.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_IniServidor.setStyleSheet("background-color: rgb(255, 179, 102)")
        self.ui.btn_IniTerminal.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_Motores.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_DetFacial.setStyleSheet("background-color: rgb(255, 179, 102)")

    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        self.ui.btn_IniServidor.clicked.connect(self.Servidor)
        self.ui.btn_DetFacial.clicked.connect(self.abrirDetecccionFacial)
        self.ui.btn_IniTerminal.clicked.connect(self.Terminal)
        self.ui.btn_Motores.clicked.connect(self.abrirMotores)
        self.ui.btn_TextoVoz.clicked.connect(self.TextoVoz)
        self.ui.btn_VozTexto.clicked.connect(self.VozTexto)

    def Servidor(self):
        if self.ui.btn_IniServidor.text() == "Iniciar\nServidor":
            try:
                ip = self.get_ip_address('wlan0')
                self.ui.btn_IniServidor.setStyleSheet("background-color: rgb(255, 0, 0)")
                self.ui.btn_IniServidor.setText("Apagar\nServidor")
                self.proc = subprocess.Popen(['python', 'Servidor/servidorRaspberry.py'])
                print self.proc.pid
                QMessageBox.about(self, 'Alerta', 'Conectarse a ' + str(ip) + ':5000\npara poder acceder al control remoto')
            except IOError:
                QMessageBox.about(self, 'Alerta', 'No se ha conectado a ninguna red inalambrica')
        else:
            self.ui.btn_IniServidor.setText("Iniciar\nServidor")
            self.ui.btn_IniServidor.setStyleSheet("background-color: rgb(255, 179, 102)")
            self.proc.send_signal(signal.SIGINT)
            subprocess.check_output("lsof -i :5000 | grep 'python'| cut -d ' ' -f3 | xargs kill -9", shell=True)

    def iniciarServidor(self):
        self.servidor.run(host='0.0.0.0', threaded=True)


    def abrirDetecccionFacial(self):
        self.deteccionFacial = VentanaDeteccionFacial()
        self.deteccionFacial.abrirVentanaCamara(self)
        self.show()

    def Terminal(self):
        #self.hide()
        self.proc1 = subprocess.Popen(['xterm', '-fa', '"Monospace"', '-fs', '10', '-geometry', '99x15+0+0'])
        print "terminal: " + str(self.proc1.pid)
        self.proc2 = subprocess.Popen(['florence', '--use-config', 'Ventanas/florence.conf'])
        print "florence: " + str(self.proc2.pid)
        self.proc1.wait()
        time.sleep(0.1)
        #self.show()
        subprocess.check_output("kill -9 " + str(self.proc2.pid), shell=True)

    def abrirMotores(self):
        self.ventanaAbierta = 'motores'
        self.motores = VentanaMotores(self.Datos)
        self.motores.show()
        self.close()
        self.motores.c.Back.connect(self.backMenu)


    def TextoVoz(self):
        self.ventanaAbierta = 'TextoVoz'
        self.TextoVoz= VentanaProbarTts(self.Datos)
        self.TextoVoz.show()
        self.close()
        self.TextoVoz.c.Back.connect(self.backMenu)

    def VozTexto(self):
        self.ventanaAbierta = 'VozTexto'
        self.VozTexto= VentanaPruebaStt(self.Datos)
        self.VozTexto.show()
        self.close()
        self.VozTexto.c.Back.connect(self.backMenu)

    def clickAtras(self, event):
        self.c.Back.emit()

    def backMenu(self):
        self.show()
        comando = "self." + self.ventanaAbierta + ".close()"
        eval(comando)


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaFuncEspecificas()
    myapp.show()
    sys.exit(app.exec_())


