# -*- coding: utf-8 -*-
import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from intervencionLenguaje import Ui_frm_Intervencion

from AplicacionCodigo.Ventanas.VentanaElegirEjercicio import VentanaElegirEjercicio


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaIntervencion(QtGui.QWidget):

    def __init__(self, Datos, DatosPac):
        super(VentanaIntervencion, self).__init__()
        self.datos = Datos
        self.datosPac = DatosPac
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_Intervencion()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.InfoPac()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_intervencionLenguajeE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Fonologica.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_Morfosintactica.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_Semantica.setStyleSheet("background-color: rgb(255, 179, 102)")


    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_Fonologica.clicked.connect(self.AbrirVentanaElegirEjercicio)
        self.ui.btn_Morfosintactica.clicked.connect(self.AbrirVentanaElegirEjercicio)
        self.ui.btn_Semantica.clicked.connect(self.AbrirVentanaElegirEjercicio)


    def AbrirVentanaElegirEjercicio(self):
        sender = self.sender()
        self.ventanaAbierta = 'ElegirEjercicio'
        self.ElegirEjercicio = VentanaElegirEjercicio(self.datos, self.datosPac, sender.toolTip(), sender.text(), 'Intervención del Lenguaje')
        self.ElegirEjercicio.show()
        self.close()
        self.ElegirEjercicio.c.Back.connect(self.backMenu)

    def clickSalir(self, event):
        self.c.Back.emit()

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaIntervencion()
    myapp.show()
    sys.exit(app.exec_())




