import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from login import Ui_frm_login

from AplicacionCodigo.BaseDatos.ConectorBD import *
from AplicacionCodigo.Ventanas.VentanaWifi import VentanaWifi

class Communicate(QtCore.QObject):
    closeApp = QtCore.pyqtSignal()


class VentanaLogin(QtGui.QWidget):

    def __init__(self):
        super(VentanaLogin, self).__init__()
        self.c = Communicate()

        #Iniciar Interfaz Grafica
        self.ui = Ui_frm_login()
        self.ui.setupUi(self)
        self.activacionBotones()
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.l = False

        #Conexion a la Base de datos
        self.conector = ConectorBD()
        usuarios = self.conector.obtenerUsuarios()
        for user in usuarios:
            self.ui.comboBox.addItem(user[0])

    def activacionBotones(self):
        self.clave = ''
        self.pista = ''
        self.ui.label.setText("")
        self.contadorClave = 0
        if self.ui.comboBox.currentIndex() == 0:
            for i in range (1, 11, 1):
                eval('self.ui.btn_' + str(i) + '.setEnabled(False)')
        if self.ui.comboBox.currentIndex() > 0:
            for i in range (1, 11, 1):
                eval('self.ui.btn_' + str(i) + '.setEnabled(True)')

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_loginE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        for i in range(1, 11, 1):
            self.boton = eval('self.ui.btn_' + str(i))
            self.region = QtGui.QRegion(QtCore.QRect(2.5, 2.5, 75, 75), QtGui.QRegion.Ellipse)
            self.boton.setMask(self.region)
            self.boton.setStyleSheet("QPushButton { background-color: rgb(230, 255, 204) }"
                                     "QPushButton:pressed { background-color: rgb(102, 153, 255) }")

    def conexiones(self):
        for j in range(1, 11, 1):
            self.comando = 'self.ui.btn_' + str(j) + '.clicked.connect(self.digitoClave)'
            eval(self.comando)
        self.ui.comboBox.currentIndexChanged.connect(self.activacionBotones)
        self.ui.btnl_apagar.mousePressEvent = self.clickApagar
        self.ui.btnl_wifi.mousePressEvent = self.abrirWifi

    def digitoClave(self):

        sender = self.sender()

        if self.contadorClave < 4:
            self.clave = self.clave + (sender.text())
            self.pista = self.pista + '*'
            self.contadorClave += 1
            self.ui.label.setText(self.pista)
        if self.contadorClave == 4:
            self.verificarLogin(self.clave, self.ui.comboBox.currentText())
            self.clave = ''
            self.contadorClave = 0

    def verificarLogin(self, clave, usuario):
        self.l = self.conector.login(str(usuario), str(clave))
        if self.l:
            self.DatosLog = self.conector.obtenerDatosLog(str(usuario), str(clave))
            self.c.closeApp.emit()
        else:
            QMessageBox.about(self, 'Alerta', 'Clave Incorrecta')
            self.pista = ''
            self.ui.label.setText(self.pista)


    def abrirWifi(self, event):
        self.ventanaAbierta = 'wifi'
        self.wifi = VentanaWifi()
        self.wifi.show()
        self.wifi.abrirVentana()
        self.close()
        self.wifi.c.Back.connect(self.backMenu)


    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

    def clickApagar(self, event):
        sys.exit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    login = VentanaLogin()
    login.show()
    sys.exit(app.exec_())


