# -*- coding: utf-8 -*-

import sys
import time
import urllib
import socket
import fcntl
import struct
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from menuPrincipalAdmin import Ui_frm_MenuPrincipal_Admin
from AplicacionCodigo.Ventanas.VentanaSMUser import VentanaSMUser
from AplicacionCodigo.Ventanas.VentanaRegistros import VentanaRegistros
from AplicacionCodigo.Ventanas.VentanaAutonomoControl import VentanaAutonomoControl

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)


class Communicate(QtCore.QObject):
    closeApp = QtCore.pyqtSignal()

class VentanaMPAdmin(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaMPAdmin, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_MenuPrincipal_Admin()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()

    def get_ip_address(self, ifname):
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        return socket.inet_ntoa(fcntl.ioctl(
            s.fileno(),
            0x8915,  # SIOCGIFADDR
            struct.pack('256s', ifname[:15])
        )[20:24])


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuAdmE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Paciente.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_Usuarios.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_Registro.setStyleSheet("background-color: rgb(255, 179, 102)")
        if self.datos[2] == 'SuperUsuario':
            self.ui.btnl_Salir.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/iconoAtras.png"))


    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_Usuarios.clicked.connect(self.abrirManUser)
        self.ui.btn_Paciente.clicked.connect(self.abrirManUser)
        self.ui.btn_Registro.clicked.connect(self.abrirRegistros)
        self.ui.btnl_Autonomo.mousePressEvent = self.abrirAutonomo
        self.ui.btnl_Remoto.mousePressEvent = self.abrirControl

    def abrirManUser(self):
        sender = self.sender()
        self.ventanaAbierta = "manUser"
        self.manUser = VentanaSMUser(self.datos, sender.text())
        self.manUser.show()
        self.close()
        self.manUser.c.Back.connect(self.backMenu)

    def abrirRegistros(self):
        self.ventanaAbierta = 'registros'
        self.registros = VentanaRegistros(self.datos)
        self.registros.show()
        self.close()
        self.registros.c.Back.connect(self.backMenu)

    def abrirAutonomo(self, event):
        try:
            ip = self.get_ip_address('wlan0')
            QMessageBox.about(self, 'Alerta', _translate('Autonomo','Comprobando conexión a internet, por favor espere', None))
            url = "https://es.wikipedia.org/wiki/"+str('gato'.replace(" ","_").lower())
            html = urllib.urlopen(url).read()
            self.ventanaAbierta = 'autonomo'
            self.autonomo = VentanaAutonomoControl('autonomo')
            self.autonomo.show()
            self.close()
            self.autonomo.c.Back.connect(self.backMenu)
        except IOError:
            QMessageBox.about(self, 'Alerta', _translate('Autonomo','Lo siento, no se puede abrir el modo\nautónomo sin conexión a internet', None))

    def abrirControl(self, event):
         try:
            ip = self.get_ip_address('wlan0')
            self.ventanaAbierta = 'control'
            self.control = VentanaAutonomoControl('control')
            self.control.show()
            self.close()
            self.control.c.Back.connect(self.backMenu)
         except IOError:
            QMessageBox.about(self, 'Alerta', 'No se ha conectado a ninguna red inalambrica')


    def backMenu(self):
        self.show()
        comando = "self." + self.ventanaAbierta + ".close()"
        eval(comando)

    def clickSalir(self, event):
        self.setEnabled(False)
        self.c.closeApp.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaMPAdmin()
    myapp.show()
    sys.exit(app.exec_())


