import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from menuPrincipalSuperU import Ui_frm_MenuPrincipal_SuperU
from AplicacionCodigo.Ventanas.VentanaFuncEspecificas import VentanaFuncEspecificas
from AplicacionCodigo.Ventanas.VentanaBaseDatos import VentanaBaseDatos
from AplicacionCodigo.Ventanas.VentanaMPAdmin import VentanaMPAdmin



class Communicate(QtCore.QObject):
    closeApp = QtCore.pyqtSignal()

class VentanaMPSuperU(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaMPSuperU, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_MenuPrincipal_SuperU()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuSuperUE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_cuentaAdmin.setStyleSheet("background-color: rgb(255, 204, 51)")
        self.ui.btn_FuncEsp.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_BaseDatos.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_AgregarAct.setStyleSheet("background-color: rgb(255, 179, 102)")

    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_FuncEsp.clicked.connect(self.abrirFuncEspec)
        self.ui.btn_BaseDatos.clicked.connect(self.abrirBaseDatos)
        self.ui.btn_cuentaAdmin.clicked.connect(self.abrirAdministrador)

    def clickSalir(self, event):
        self.setEnabled(False)
        self.c.closeApp.emit()

    def abrirFuncEspec(self):
        self.ventanaAbierta = "funcEspec"
        self.funcEspec = VentanaFuncEspecificas(self.datos)
        self.funcEspec.show()
        self.close()
        self.funcEspec.c.Back.connect(self.backMenu)

    def abrirBaseDatos(self):
        self.ventanaAbierta = "baseDatos"
        self.baseDatos = VentanaBaseDatos(self.datos)
        self.baseDatos.show()
        self.close()
        self.baseDatos.c.Back.connect(self.backMenu)

    def abrirAdministrador(self):
        self.ventanaAbierta = "admin"
        self.admin = VentanaMPAdmin(self.datos)
        self.admin.show()
        self.close()
        self.admin.c.closeApp.connect(self.backMenu)

    def backMenu(self):
        self.show()
        comando = "self." + self.ventanaAbierta + ".close()"
        eval(comando)



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaMPSuperU()
    myapp.show()
    sys.exit(app.exec_())


