# -*- coding: utf-8 -*-

import sys
import urllib
import socket
import fcntl
import struct
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from menuPrincipalTerap import Ui_frm_MenuPrincipal_Terap
from AplicacionCodigo.Ventanas.VentanaTerapias import VentanaTerapias
from AplicacionCodigo.Ventanas.VentanaSMUser import VentanaSMUser
from AplicacionCodigo.Ventanas.VentanaRegistros import VentanaRegistros
from AplicacionCodigo.Ventanas.VentanaRegistroPaciente import VentanaRegistroPaciente
from AplicacionCodigo.Ventanas.VentanaAutonomoControl import VentanaAutonomoControl
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD


try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    closeApp = QtCore.pyqtSignal()

class VentanaMPTerap(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaMPTerap, self).__init__()
        self.datos = Datos
        self.datosPac = None
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.PacId = ''
        self.UsrId = Datos[4]
        self.ui = Ui_frm_MenuPrincipal_Terap()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.c = Communicate()
        self.ui.btn_Terapia.setEnabled(True)
        self.ui.lbl_descPac.setVisible(False) ###Pasar al codigo cuando este listo
        self.ui.lbl_fotoPac.setVisible(False)

    def get_ip_address(self, ifname):
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        return socket.inet_ntoa(fcntl.ioctl(
            s.fileno(),
            0x8915,  # SIOCGIFADDR
            struct.pack('256s', ifname[:15])
        )[20:24])

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg', 'wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_MenuTerapE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Paciente.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_Terapia.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_Registro.setStyleSheet("background-color: rgb(255, 179, 102)")

    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_Terapia.clicked.connect(self.abrirTerapia)
        self.ui.btn_Registro.clicked.connect(self.abrirRegistros)
        self.ui.btn_Paciente.clicked.connect(self.abrirPaciente)
        self.ui.btnl_Autonomo.mousePressEvent = self.abrirAutonomo
        self.ui.btnl_Remoto.mousePressEvent = self.abrirControl

    def abrirTerapia(self):
        if self.PacId != '':
            self.ventanaAbierta = 'terapia'
            self.terapia = VentanaTerapias(self.datos, self.datosPac)
            self.terapia.show()
            self.close()
            self.terapia.c.Back.connect(self.backMenu)
        else:
            QMessageBox.about(self, 'Alerta', 'No se puede iniciar terapia\nsin haber seleccionado un paciente')


    def abrirPaciente(self):
        self.ventanaAbierta = 'paciente'
        self.paciente = VentanaSMUser(self.datos, "Pacientes")
        self.paciente.show()
        self.close()
        self.paciente.c.Back.connect(self.backMenuPac)

    def abrirRegistros(self):
        self.ventanaAbierta = 'registros'
        self.registros = VentanaRegistros(self.datos)
        self.registros.show()
        self.close()
        self.registros.c.Back.connect(self.backMenu)

    def abrirMostrarDatosPac(self):
        self.ventanaAbierta = "regPac"
        self.regPac = VentanaRegistroPaciente(self.datos, self.PacId)
        self.regPac.ui.btn_TomarFoto.setVisible(False)
        self.regPac.ui.label_6.setText(_translate("Informacion", "Información del Paciente", None))
        self.regPac.ui.btn_Guardar.setText("Terminar\nSesion")
        self.regPac.ui.txt_PNombre.removeEventFilter(self.regPac)
        self.regPac.ui.txt_SNombre.removeEventFilter(self.regPac)
        self.regPac.ui.txt_ApPat.removeEventFilter(self.regPac)
        self.regPac.ui.txt_ApMat.removeEventFilter(self.regPac)
        self.regPac.ui.txt_AniosCrono.removeEventFilter(self.regPac)
        self.regPac.ui.txt_MesesCrono.removeEventFilter(self.regPac)
        self.regPac.ui.txt_AniosLeng.removeEventFilter(self.regPac)
        self.regPac.ui.txt_MesesLeng.removeEventFilter(self.regPac)
        self.regPac.ui.txt_DiagMed.removeEventFilter(self.regPac)
        self.regPac.ui.txt_DiagLeng.removeEventFilter(self.regPac)
        self.regPac.ui.cb_Sexo.setEnabled(False)
        self.regPac.show()
        self.close()
        self.regPac.c.Back.connect(self.backMenu)
        self.regPac.c.terSes.connect(self.sesionTerminada)

    def abrirAutonomo(self, event):
        try:
            ip = self.get_ip_address('wlan0')
            QMessageBox.about(self, 'Alerta', _translate('Autonomo','Comprobando conexión a internet, por favor espere', None))
            url = "https://es.wikipedia.org/wiki/"+str('gato'.replace(" ","_").lower())
            html = urllib.urlopen(url).read()
            self.ventanaAbierta = 'autonomo'
            self.autonomo = VentanaAutonomoControl('autonomo')
            self.autonomo.show()
            self.close()
            self.autonomo.c.Back.connect(self.backMenu)
        except IOError:
            QMessageBox.about(self, 'Alerta', _translate('Autonomo','Lo siento, no se puede abrir el modo\nautónomo sin conexión a internet', None))

    def abrirControl(self, event):
         try:
            ip = self.get_ip_address('wlan0')
            self.ventanaAbierta = 'control'
            self.control = VentanaAutonomoControl('control')
            self.control.show()
            self.close()
            self.control.c.Back.connect(self.backMenu)
         except IOError:
            QMessageBox.about(self, 'Alerta', 'No se ha conectado a ninguna red inalambrica')

    def sesionTerminada(self):
        self.PacId = ''
        self.ui.lbl_fotoPac.setVisible(False)
        self.ui.lbl_descPac.setVisible(False)
        self.ui.btn_Paciente.clicked.disconnect()
        self.ui.btn_Paciente.clicked.connect(self.abrirPaciente)
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')


    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

    def backMenuPac(self):
        pacienteId = self.paciente.pacienteId
        if pacienteId != "":
            self.datosPac = self.conector.obtenerDatosPaciente(pacienteId)
            self.ui.lbl_fotoPac.setVisible(True)
            self.ui.lbl_descPac.setVisible(True)
            self.PacId = self.datosPac[0]
            self.conector.crearSesion(self.UsrId, self.PacId)
            self.ui.btn_Paciente.clicked.disconnect()
            self.ui.btn_Paciente.clicked.connect(self.abrirMostrarDatosPac)
            self.InfoPac()
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')


    def clickSalir(self, event):
        if self.PacId != '':
           QMessageBox.about(self, 'Alerta', 'No se puede salir sin terminar la sesion,\nDirigirse a:\n1.Paciente\n2.Terminar Sesion')
        else:
            self.setEnabled(False)
            self.c.closeApp.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaMPTerap()
    myapp.show()
    sys.exit(app.exec_())