import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from modificarRegistro import Ui_frm_modificarRegistro
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso
from AplicacionCodigo.Ventanas.VentanaSMUser import VentanaSMUser
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaModificarRegistro(QtGui.QWidget):

    def __init__(self, Datos, regId):
        super(VentanaModificarRegistro, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.regId = regId
        self.ui = Ui_frm_modificarRegistro()
        self.ui.setupUi(self)
        self.InfoUsr()
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.cargarVentana()
        self.c = Communicate()
        self.mI = VentanaMetodosIngreso()
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)


    def cargarVentana(self):
        datos = self.conector.obtenerDatosRegistro(self.regId)
        self.ui.txt_Ejercicio.setText(datos[0])
        self.ui.txt_Terapista.setText(datos[1])
        self.ui.txt_Paciente.setText(datos[2])
        self.ui.txt_Puntuacion.setText(str(datos[3]))
        self.ui.txt_Observaciones.setPlainText(datos[4])
        if datos[9] is not None:
            self.ui.txt_Observaciones_Ses.setPlainText(datos[9])
        self.sesId = datos[5]
        self.ejerId = datos[6]
        self.userId = datos[7]
        self.pacId = datos[8]


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_registrosE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Guardar.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.txt_Ejercicio.installEventFilter(self)
        self.ui.txt_Terapista.installEventFilter(self)
        self.ui.txt_Paciente.installEventFilter(self)
        self.ui.txt_Puntuacion.installEventFilter(self)
        self.ui.txt_Observaciones.installEventFilter(self)
        self.ui.txt_Observaciones_Ses.installEventFilter(self)


    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        self.ui.btn_Guardar.clicked.connect(self.verificarDatosIngresados)

    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.MouseButtonRelease):
            if (QObject is self.ui.txt_Puntuacion):
                self.mI.getNumero(2, 10, QObject)
            else:
                self.abrirTablas(QObject)
        elif (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
                self.ui.btn_Guardar.setFocus(True)
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)

    def abrirTablas(self, QObject):
        self.ventanaAbierta = "manTab"
        if QObject is self.ui.txt_Ejercicio:
            self.manTab = VentanaSMUser(self.datos, 'SEjercicios')
        elif QObject is self.ui.txt_Terapista:
            self.manTab = VentanaSMUser(self.datos, 'SUsuarios')
        else:
            self.manTab = VentanaSMUser(self.datos, 'SPacientes')
        self.manTab.ui.btn_opcion2.setVisible(False)
        self.manTab.show()
        self.close()
        self.manTab.c.Selec.connect(self.seleccionCampo)
        self.manTab.c.Back.connect(self.backMenu)

    def seleccionCampo(self):
        self.show()
        dato = self.manTab.obtenerCampo()
        if dato != None:
            if dato[1] == 'SEjercicios':
                nombre = self.conector.obtenerNombreEjercicio(dato[0])
                self.ui.txt_Ejercicio.setText(nombre)
                self.ejerId = dato[0]
            elif dato[1] == 'SUsuarios':
                nombre = self.conector.obtenerNombreUsuario(dato[0])
                if nombre[1] != "Terapista":
                    QMessageBox.about(self, 'Alerta', 'El usuario seleccionado no es Terapista')
                else:
                    print nombre[1]
                    self.ui.txt_Terapista.setText(nombre[0])
                    self.userId = dato[0]
            else:
                nombre = self.conector.obtenerNombrePaciente(dato[0])
                self.ui.txt_Paciente.setText(nombre)
                self.pacId = dato[0]
        eval('self.' + self.ventanaAbierta + '.close()')


    def verificarDatosIngresados(self):
        ejercicio = self.ui.txt_Ejercicio.text()
        terapista = self.ui.txt_Terapista.text()
        paciente = self.ui.txt_Paciente.text()
        puntuacion = self.ui.txt_Puntuacion.text()
        observaciones = self.ui.txt_Observaciones.toPlainText()
        observacionesSes = self.ui.txt_Observaciones_Ses.toPlainText()
        r = self.conector.modificarRegistro(self.regId, self.sesId, self.ejerId, self.userId, self.pacId, puntuacion,
                                            observaciones, observacionesSes)
        if r:
            QMessageBox.about(self, 'Alerta', 'Registro Modificado')
        else:
            QMessageBox.about(self, 'Alerta', 'Se produjo un error al guardar los datos')
        self.c.Back.emit()





    def clickAtras(self, event):
        self.c.Back.emit()

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaModificarRegistro()
    myapp.show()
    sys.exit(app.exec_())


