# -*- coding: utf-8 -*-
import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from observacionesSes import Ui_frm_observacionesSes
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso
from AplicacionCodigo.BaseDatos.ConectorBD import *



try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaObservacionesSesion(QtGui.QWidget):

    def __init__(self):
        super(VentanaObservacionesSesion, self).__init__()
        self.ui = Ui_frm_observacionesSes()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.conector = ConectorBD()
        self.mI = VentanaMetodosIngreso()
        self.ui.txt_observaciones.installEventFilter(self)

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_puntuacion.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Terminar.setStyleSheet("background-color: rgb(153, 255, 102)")


    def conexiones(self):
        self.ui.btn_Terminar.clicked.connect(self.clickSalir)


    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
                self.ui.btn_Terminar.setFocus(True)
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)


    def clickSalir(self):
        observaciones = self.ui.txt_observaciones.toPlainText()
        self.conector.agregarObservacionesSesion(observaciones)
        self.ui.txt_observaciones.setEnabled(False)
        QMessageBox.about(self, 'Alerta', 'Datos guardados con exito')
        self.c.Back.emit()




if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaObservacionesSesion()
    myapp.show()
    sys.exit(app.exec_())

