# -*- coding: utf-8 -*-
import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from puntuacion import Ui_frm_puntuacion
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso
from AplicacionCodigo.BaseDatos.ConectorBD import *
import pygame


try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaPuntuacion(QtGui.QWidget):

    def __init__(self, Datos, DatosPac, puntuacion, idEjercicio, regIntentos, dificultad):
        super(VentanaPuntuacion, self).__init__()
        self.datos = Datos
        self.datosPac = DatosPac
        self.idEjercicio = idEjercicio
        self.puntuacion = puntuacion
        self.registroIntentos = regIntentos
        self.dificultad = dificultad
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_puntuacion()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.InfoUsr()
        self.InfoPac()
        self.conexiones()
        self.c = Communicate()
        self.conector = ConectorBD()
        self.mI = VentanaMetodosIngreso()
        self.ui.txt_observaciones.installEventFilter(self)
        self.ui.lbl_Puntuacion.setText(_translate("frm_puntuacion", "LA PUNTUACIÓN ES: " + str(puntuacion), None))


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_puntuacion.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Terminar.setStyleSheet("background-color: rgb(153, 255, 102)")
        cursor = self.ui.txt_observaciones.textCursor()
        cursor.movePosition(QtGui.QTextCursor.Start)


    def conexiones(self):
        self.ui.btn_Terminar.clicked.connect(self.clickSalir)


    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
                self.ui.btn_Terminar.setFocus(True)
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)


    def clickSalir(self):
        observaciones = self.ui.txt_observaciones.toPlainText()
        self.conector.guardarPuntuacion(self.idEjercicio, self.datos[4], self.datosPac[0], self.dificultad,
                                        self.puntuacion, self.registroIntentos, observaciones)
        self.ui.txt_observaciones.setEnabled(False)
        QMessageBox.about(self, 'Alerta', 'Datos guardados con exito')
        self.c.Back.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaPuntuacion()
    myapp.show()
    sys.exit(app.exec_())

