import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from registroPaciente import Ui_frm_registroPaciente
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso
from AplicacionCodigo.Ventanas.VentanaDeteccionFacial import VentanaDeteccionFacial
from AplicacionCodigo.Ventanas.VentanaObservacionesSesion import VentanaObservacionesSesion
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()
    terSes = QtCore.pyqtSignal()

class VentanaRegistroPaciente(QtGui.QWidget):

    def __init__(self, Datos, pacId):
        super(VentanaRegistroPaciente, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.PacienteId = pacId
        self.ui = Ui_frm_registroPaciente()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.c = Communicate()
        self.cargarVentana()
        self.mI = VentanaMetodosIngreso()
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def cargarVentana(self):
        if self.PacienteId != '':
            datos = self.conector.obtenerDatosPaciente(self.PacienteId)
            self.ui.btn_Guardar.setText("Modificar")
            self.guardarFoto(datos[10])
            self.ui.lbl_foto.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UltimaFoto.jpg"))
            self.ui.txt_PNombre.setText(datos[1])
            self.ui.txt_SNombre.setText(datos[2])
            self.ui.txt_ApPat.setText(datos[3])
            self.ui.txt_ApMat.setText(datos[4])
            self.ui.txt_AniosCrono.setText(str(datos[5]/12))
            self.ui.txt_MesesCrono.setText(str(datos[5]%12))
            self.ui.txt_AniosLeng.setText(str(datos[6]/12))
            self.ui.txt_MesesLeng.setText(str(datos[6]%12))
            if datos[7] == 'Masculino':
                self.ui.cb_Sexo.setCurrentIndex(0)
            else:
                self.ui.cb_Sexo.setCurrentIndex(1)
            self.ui.txt_DiagMed.setPlainText(str(datos[8]))
            self.ui.txt_DiagLeng.setPlainText(str(datos[9]))

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_registrosE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Guardar.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_TomarFoto.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.cb_Sexo.setFocus(True)
        self.ui.txt_PNombre.installEventFilter(self)
        self.ui.txt_SNombre.installEventFilter(self)
        self.ui.txt_ApPat.installEventFilter(self)
        self.ui.txt_ApMat.installEventFilter(self)
        self.ui.txt_ApPat.installEventFilter(self)
        self.ui.txt_AniosCrono.installEventFilter(self)
        self.ui.txt_MesesCrono.installEventFilter(self)
        self.ui.txt_AniosLeng.installEventFilter(self)
        self.ui.txt_MesesLeng.installEventFilter(self)
        self.ui.txt_DiagLeng.installEventFilter(self)
        self.ui.txt_DiagMed.installEventFilter(self)

    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        self.ui.btn_TomarFoto.clicked.connect(self.tomarFoto)
        self.ui.btn_Guardar.clicked.connect(self.verificarDatosIngresados)

    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.MouseButtonRelease):
            if (QObject is self.ui.txt_AniosCrono) or (QObject is self.ui.txt_AniosLeng):
                self.mI.getNumero(2, 40, QObject)
            elif (QObject is self.ui.txt_MesesCrono) or (QObject is self.ui.txt_MesesLeng):
                self.mI.getNumero(2, 11, QObject)
            else:
                self.mI.getTexto(QObject, QObject.text())
        elif (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
                self.ui.cb_Sexo.setFocus(True)
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)

    def tomarFoto(self):
        self.deteccionFacial = VentanaDeteccionFacial()
        self.deteccionFacial.abrirVentanaCamara(self)
        self.ui.lbl_foto.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UltimaFoto.jpg"))
        self.ui.lbl_foto.setScaledContents(True)
        self.show()

    def guardarFoto(self, foto):
        try:
            fout = open('../AplicacionCodigo/Estatico/UltimaFoto.jpg', 'wb')
            fout.write(foto)
        except IOError, e:
            print "Error %d: %s" % (e.args[0], e.args[1])
            sys.exit(1)
        finally:
            if fout:
                fout.close()

    def verificarDatosIngresados(self):
        sender = self.sender()
        boton = sender.text()
        pnombre = self.ui.txt_PNombre.text()
        snombre = self.ui.txt_SNombre.text()
        apellidop = self.ui.txt_ApPat.text()
        apellidom = self.ui.txt_ApMat.text()
        sexo = self.ui.cb_Sexo.currentText()
        aniosCron = self.ui.txt_AniosCrono.text()
        mesesCron = self.ui.txt_MesesCrono.text()
        aniosLeng = self.ui.txt_AniosLeng.text()
        mesesLeng = self.ui.txt_MesesLeng.text()
        diagMed = self.ui.txt_DiagMed.toPlainText()
        diagLeng = self.ui.txt_DiagLeng.toPlainText()
        foto = self.leerImagen()
        edadLeng = int(aniosLeng)*12 + int(mesesLeng)
        edadCron = int(aniosCron)*12 + int(mesesLeng)
        if (pnombre == "" or snombre == "" or apellidop == "" or apellidom == "" or sexo == "" or aniosCron == ""
            or mesesCron == "" or aniosLeng == "" or mesesLeng == "" or diagMed == "" or diagLeng == ""):
            QMessageBox.about(self, 'Alerta', 'Uno o varios campos se encuentran vacios')
        elif self.ui.lbl_foto.pixmap() == None:
            QMessageBox.about(self, 'Alerta', 'No se tiene una fotografia disponible')
        else:
            if boton == 'Guardar':
                re = self.conector.guardarDatosPaciente(pnombre, snombre, apellidop, apellidom,
                                                        edadCron, edadLeng, sexo, diagMed, diagLeng, foto)
                if re:
                    QMessageBox.about(self, 'Alerta', 'Registro Exitoso')
                    self.setEnabled(False)
                    self.c.Back.emit()
                else:
                    QMessageBox.about(self, 'Alerta', 'El usuario solicitado ya existe')
            elif boton == 'Modificar':
                re = self.conector.modificarDatosPaciente(self.PacienteId, pnombre, snombre, apellidop, apellidom,
                                                         edadCron, edadCron, sexo, diagMed, diagLeng, foto)
                if re:
                    QMessageBox.about(self, 'Alerta', 'Registro Exitoso')
                    self.c.Back.emit()
                else:
                    QMessageBox.about(self, 'Alerta', 'El usuario solicitado ya existe')
            elif boton == 'Terminar\nSesion':
                self.abrirObservacionesSesion()

    def abrirObservacionesSesion(self):
        self.ventanaAbierta = 'obsSes'
        self.obsSes = VentanaObservacionesSesion()
        self.obsSes.show()
        self.close()
        self.obsSes.c.Back.connect(self.clickSalirObservaciones)

    def leerImagen(self):
        try:
            fin = open("../AplicacionCodigo/Estatico/UltimaFoto.jpg", "rb")
            img = fin.read()
            return img
        except IOError, e:
            print "Error %d: %s" % (e.args[0], e.args[1])
            sys.exit(1)
        finally:
            if fin:
                fin.close()

    def clickAtras(self, event):
        self.c.Back.emit()

    def clickSalirObservaciones(self):
        eval('self.' + self.ventanaAbierta + '.close()')
        self.c.terSes.emit()

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaRegistroPaciente()
    myapp.show()
    sys.exit(app.exec_())


