import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from registroUsuario import Ui_frm_RegistroUsuario
from AplicacionCodigo.Ventanas.VentanaDeteccionFacial import VentanaDeteccionFacial
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso

from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaRegistroUsuario(QtGui.QWidget):

    def __init__(self, Datos, UserId):
        super(VentanaRegistroUsuario, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.LogId = None
        self.ui = Ui_frm_RegistroUsuario()
        self.UsuarioId = UserId
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.cargarVentana()
        self.c = Communicate()
        self.ui.txt_PNombre.setFocus(False)
        self.mI = VentanaMetodosIngreso()
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)


    def cargarVentana(self):
        if self.UsuarioId != '':
            datos = self.conector.obtenerDatosUsuario(self.UsuarioId)
            self.UsuarioId = datos[0]
            self.ui.btn_Guardar.setText("Modificar")
            self.guardarFoto(datos[8])
            self.ui.txt_PNombre.setText(datos[1])
            self.ui.txt_SNombre.setText(datos[2])
            self.ui.txt_ApPat.setText(datos[3])
            self.ui.txt_ApMat.setText(datos[4])
            self.ui.txt_AreaEsp.setText(datos[5])
            self.ui.txt_AreaTrab.setText(datos[6])
            self.ui.lbl_foto.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UltimaFoto.jpg"))
            self.ui.txt_Usuario.setText(datos[10])
            self.ui.txt_Password.setText(datos[11])
            if datos[7] == 'SuperUsuario':
                self.ui.cb_rol.setCurrentIndex(3)
            elif datos[7] == 'Administrador':
                self.ui.cb_rol.setCurrentIndex(2)
            else:
                self.ui.cb_rol.setCurrentIndex(1)

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_registrosE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def modificarBotones(self):
        self.ui.btn_Guardar.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_TomarFoto.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.txt_PNombre.installEventFilter(self)
        self.ui.txt_SNombre.installEventFilter(self)
        self.ui.txt_ApPat.installEventFilter(self)
        self.ui.txt_ApMat.installEventFilter(self)
        self.ui.txt_AreaEsp.installEventFilter(self)
        self.ui.txt_AreaTrab.installEventFilter(self)
        self.ui.txt_Usuario.installEventFilter(self)
        self.ui.txt_Password.installEventFilter(self)
        if self.datos[2] == "Administrador":
            self.ui.cb_rol.addItem("Terapista")
        if self.datos[2] == "SuperUsuario":
            self.ui.cb_rol.addItem("Terapista")
            self.ui.cb_rol.addItem("Administrador")
            self.ui.cb_rol.addItem("SuperUsuario")

    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        self.ui.btn_Guardar.clicked.connect(self.verificarDatosIngresados)
        self.ui.btn_TomarFoto.clicked.connect(self.tomarFoto)

    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.MouseButtonRelease):
            if (QObject is self.ui.txt_Password):
                self.mI.getNumero(4, 9999, QObject)
            else:
                self.mI.getTexto(QObject, QObject.text())
        elif (QEvent.type() == QtCore.QEvent.FocusIn):
            if isinstance(QObject, QtGui.QPlainTextEdit):
                self.mI.getTexto(QObject, QObject.toPlainText())
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)

    def tomarFoto(self):
        self.deteccionFacial = VentanaDeteccionFacial()
        self.deteccionFacial.abrirVentanaCamara(self)
        self.ui.lbl_foto.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UltimaFoto.jpg"))
        self.ui.lbl_foto.setScaledContents(True)
        self.show()

    def verificarDatosIngresados(self):
        sender = self.sender()
        boton = sender.text()
        pnombre = self.ui.txt_PNombre.text()
        snombre = self.ui.txt_SNombre.text()
        apellidop = self.ui.txt_ApPat.text()
        apellidom = self.ui.txt_ApMat.text()
        areaT = self.ui.txt_AreaTrab.text()
        areaE = self.ui.txt_AreaEsp.text()
        username = self.ui.txt_Usuario.text()
        passw = self.ui.txt_Password.text()
        rol = self.ui.cb_rol.currentText()
        foto = self.leerImagen()
        if pnombre == "" or snombre == "" or apellidop == "" or apellidom == "" or areaE == "" or areaT == "" or username == "" or passw == "" or rol == "":
            QMessageBox.about(self, 'Alerta', 'Uno o varios campos se encuentran vacios')
        elif self.ui.lbl_foto.pixmap() == None:
            QMessageBox.about(self, 'Alerta', 'No se tiene una fotografia disponible')
        else:
            if boton == 'Guardar':
                re = self.conector.guardarDatosUsuario(pnombre, snombre, apellidop, apellidom, areaE, areaT, username,
                                                       passw, rol, foto)
                if re:
                    QMessageBox.about(self, 'Alerta', 'Registro Exitoso')
                    self.setEnabled(False)
                    self.c.Back.emit()
                else:
                    QMessageBox.about(self, 'Alerta', 'El usuario solicitado ya existe')
            elif boton == 'Modificar':
                re = self.conector.modificarDatosUsuario(self.UsuarioId, pnombre, snombre, apellidop, apellidom, areaE,
                                                         areaT, username, passw, rol, foto)
                if re:
                    QMessageBox.about(self, 'Alerta', 'Registro Exitoso')
                    self.c.Back.emit()
                else:
                    QMessageBox.about(self, 'Alerta', 'El usuario solicitado ya existe')

    def guardarFoto(self, foto):
        try:
            fout = open('../AplicacionCodigo/Estatico/UltimaFoto.jpg', 'wb')
            fout.write(foto)
        except IOError, e:
            print "Error %d: %s" % (e.args[0], e.args[1])
            sys.exit(1)
        finally:
            if fout:
                fout.close()

    def leerImagen(self):
        try:
            fin = open("../AplicacionCodigo/Estatico/UltimaFoto.jpg", "rb")
            img = fin.read()
            return img
        except IOError, e:
            print "Error %d: %s" % (e.args[0], e.args[1])
            sys.exit(1)
        finally:
            if fin:
                fin.close()


    def clickAtras(self, event):
        self.c.Back.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaRegistroUsuario()
    myapp.show()
    sys.exit(app.exec_())


