import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from registros import Ui_frm_registros
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD
from AplicacionCodigo.Ventanas.VentanaModificarRegistro import VentanaModificarRegistro
from AplicacionCodigo.Ventanas.VentanaDetallesRegistro import VentanaDetallesRegistro
import time



class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaRegistros(QtGui.QWidget):

    def __init__(self, Datos):
        super(VentanaRegistros, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_registros()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.c = Communicate()
        self.ui.btn_filtrar.setFocus()
        self.mI = VentanaMetodosIngreso()


    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_registrosE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_modificar.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_filtrar.setStyleSheet("background-color: rgb(153, 255, 102)")
        if self.datos[2] == "Administrador" or self.datos[2] == "SuperUsuario":
            self.ui.btn_modificar.setVisible(True)
        else:
            self.ui.btn_modificar.setText('Detalles')
        self.ui.btnl_Atras.mousePressEvent = self.clickSalir
        self.ui.txt_hint.installEventFilter(self)
        self.ui.date_Desde.calendarWidget().setLocale(QtCore.QLocale(QtCore.QLocale.Spanish, QtCore.QLocale.Ecuador))
        self.ui.date_Desde.calendarWidget().setHorizontalHeaderFormat(QtGui.QCalendarWidget.SingleLetterDayNames)
        self.ui.date_Desde.calendarWidget().setVerticalHeaderFormat(QtGui.QCalendarWidget.NoVerticalHeader)
        self.ui.date_Hasta.calendarWidget().setLocale(QtCore.QLocale(QtCore.QLocale.Spanish, QtCore.QLocale.Ecuador))
        self.ui.date_Hasta.calendarWidget().setHorizontalHeaderFormat(QtGui.QCalendarWidget.SingleLetterDayNames)
        self.ui.date_Hasta.calendarWidget().setVerticalHeaderFormat(QtGui.QCalendarWidget.NoVerticalHeader)
        self.ui.tbl_salidaFiltro.horizontalHeader().setResizeMode(QtGui.QHeaderView.Stretch)
        self.ui.tbl_salidaFiltro.verticalHeader().setResizeMode(QtGui.QHeaderView.ResizeToContents)
        self.ui.tbl_salidaFiltro.setSortingEnabled(True)
        self.ui.date_Desde.setDate(QtCore.QDate.currentDate())
        self.ui.date_Hasta.setDate(QtCore.QDate.currentDate())

    def conexiones(self):
        self.ui.btn_filtrar.clicked.connect(self.cargarTablas)
        self.ui.date_Desde.dateChanged.connect(self.cargarTablas)
        self.ui.date_Hasta.dateChanged.connect(self.cargarTablas)
        if self.datos[2] == "Administrador" or self.datos[2] == "SuperUsuario":
            self.ui.btn_modificar.clicked.connect(self.abrirModRegistro)
        else:
            self.ui.btn_modificar.clicked.connect(self.abrirDetalles)



    def eventFilter(self, QObject, QEvent):
        if (QEvent.type() == QtCore.QEvent.MouseButtonRelease):
            if (QObject is self.ui.txt_hint):
                self.mI.getTexto(QObject, QObject.text())
        return QtGui.QWidget.eventFilter(self, QObject, QEvent)

    def abrirModRegistro(self):
        regId = self.filaSeleccionada()
        if regId == '':
            QMessageBox.about(self, 'Alerta', 'No se ha seleccinado un registro')
        else:
            self.ventanaAbierta = 'modReg'
            self.modReg = VentanaModificarRegistro(self.datos, regId)
            self.modReg.show()
            self.close()
            self.modReg.c.Back.connect(self.backMenu)

    def abrirDetalles(self):
        regId = self.filaSeleccionada()
        if regId == '':
            QMessageBox.about(self, 'Alerta', 'No se ha seleccinado un registro')
        else:
            self.ventanaAbierta = 'detalles'
            self.detalles = VentanaDetallesRegistro(self.datos, regId)
            self.detalles.show()
            self.close()
            self.detalles.c.Back.connect(self.backMenu)

    def filaSeleccionada(self):
        index = self.ui.tbl_salidaFiltro.currentIndex()
        idRegistro = index.sibling(index.row(), 0).data().toString()
        return idRegistro

    def cargarTablas(self):
        texto = self.ui.txt_hint.text()
        desde = self.ui.date_Desde.text()
        hasta = self.ui.date_Hasta.text()
        modelo = self.conector.cargarRegistros(texto, self.ui.cb_fiiltrarPor.currentText(), desde, hasta)
        self.ui.tbl_salidaFiltro.setModel(modelo)
        self.ui.tbl_salidaFiltro.hideColumn(0)

    def backMenu(self):
        self.show()
        self.cargarTablas()
        eval('self.' + self.ventanaAbierta + '.close()')

    def clickSalir(self, event):
        self.c.Back.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaRegistros()
    myapp.show()
    sys.exit(app.exec_())


