# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from seleccionarModificarUser import Ui_frm_seleccionarModificarUser
from AplicacionCodigo.Ventanas.VentanaRegistroUsuario import VentanaRegistroUsuario
from AplicacionCodigo.Ventanas.VentanaRegistroPaciente import VentanaRegistroPaciente
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD


class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()
    Selec = QtCore.pyqtSignal()

class VentanaSMUser(QtGui.QWidget):

    def __init__(self, Datos, qenvia):
        self.qenvia = qenvia
        super(VentanaSMUser, self).__init__()
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.pacienteId = ''
        self.usuarioId = ''
        self.ui = Ui_frm_seleccionarModificarUser()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.modificarBotones()
        self.conexiones()
        self.c = Communicate()
        self.conector = ConectorBD()
        self.cambioTab()

    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_regSelModUser.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_opcion1.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_opcion2.setStyleSheet("background-color: rgb(102, 179, 255)")
        if self.qenvia == "Usuarios":
            self.ui.lbl_titulo.setText("Modificar o Registrar Usuario")
            self.ui.btn_opcion1.setText("Modificar\nUsuario")
            self.ui.btn_opcion2.setText("Registrar\nUsuario")
        elif self.qenvia == "Pacientes":
            if self.datos[2] == "SuperUsuario" or self.datos[2] == "Administrador":
                self.ui.lbl_titulo.setText("Modificar o Registrar Paciente")
                self.ui.btn_opcion1.setText("Modificar\nPaciente")
                self.ui.btn_opcion2.setText("Registrar\nPaciente")
            else:
                self.ui.lbl_titulo.setText("Seleccionar o Registrar Paciente")
                self.ui.btn_opcion1.setText("Seleccionar\nPaciente")
                self.ui.btn_opcion2.setText("Registrar\nPaciente")
        else:
            self.ui.btn_opcion1.setText('Seleccionar')



    def conexiones(self):
        self.ui.btnl_Atras.mousePressEvent = self.clickAtras
        if self.ui.btn_opcion1.text() == "Modificar\nPaciente":
            self.ui.btn_opcion1.clicked.connect(self.abrirModPac)
        elif self.ui.btn_opcion1.text() == "Modificar\nUsuario":
            self.ui.btn_opcion1.clicked.connect(self.abrirModUser)
        elif self.ui.btn_opcion1.text() == "Seleccionar\nPaciente":
            self.ui.btn_opcion1.clicked.connect(self.abrirSelecPac)
        else:
            self.ui.btn_opcion1.clicked.connect(self.clickSelec)
        if self.ui.btn_opcion2.text() == "Registrar\nPaciente":
            self.ui.btn_opcion2.clicked.connect(self.abrirRegPac)
        else:
            self.ui.btn_opcion2.clicked.connect(self.abrirRegUser)
        self.ui.tab_Pacientes.currentChanged.connect(self.cambioTab)

    def cambioTab(self):
        index = self.ui.tab_Pacientes.currentIndex()
        tool = self.ui.tab_Pacientes.tabToolTip(index)
        if self.qenvia == "SUsuarios":
            self.conector.cargarUser("Usuarios", index, tool, self.ui)
        elif self.qenvia == "SPacientes":
            self.conector.cargarUser("Pacientes", index, tool, self.ui)
        elif self.qenvia == "SEjercicios":
            self.conector.cargarUser("Ejercicios", index, tool, self.ui)
        else:
            self.conector.cargarUser(self.qenvia, index, tool, self.ui)

        #self.ui.tbl_0.verticalHeader().setDefaultSectionSize(24)


    def filaSeleccionada(self):
        indexTab = self.ui.tab_Pacientes.currentIndex()
        comando = 'self.ui.tbl_' + str(indexTab) + '.currentIndex()'
        index = eval(comando)
        idUserPac = index.sibling(index.row(), 0).data().toString()
        return idUserPac

    def abrirRegPac(self):
        self.ventanaAbierta = "regPac"
        self.regPac = VentanaRegistroPaciente(self.datos, self.pacienteId)
        self.regPac.show()
        self.close()
        self.regPac.c.Back.connect(self.backMenu)

    def abrirRegUser(self):
        self.ventanaAbierta = "regUser"
        self.regUser = VentanaRegistroUsuario(self.datos, self.usuarioId)
        self.regUser.show()
        self.close()
        self.regUser.c.Back.connect(self.backMenu)

    def abrirModPac(self):
        pacienteId = self.filaSeleccionada()
        if pacienteId != '':
            self.ventanaAbierta = "regPac"
            self.regPac = VentanaRegistroPaciente(self.datos, pacienteId)
            self.regPac.show()
            self.close()
            self.regPac.c.Back.connect(self.backMenu)
        else:
            QMessageBox.about(self, 'Alerta', 'No ha seleccionado ningun campo')


    def abrirModUser(self):
        usuarioId = self.filaSeleccionada()
        datos = self.conector.obtenerDatosUsuario(usuarioId)
        if usuarioId != "":
            if self.datos[2] == 'Administrador':
                if datos[7] == 'Administrador' or datos[7] == 'SuperUsuario':
                    QMessageBox.about(self, 'Alerta', 'No tiene permisos para realizar esta accion')
                else:
                    self.ventanaAbierta = "regUser"
                    self.regUser = VentanaRegistroUsuario(self.datos, usuarioId)
                    self.regUser.show()
                    self.close()
                    self.regUser.c.Back.connect(self.backMenu)
            else:
                self.ventanaAbierta = "regUser"
                self.regUser = VentanaRegistroUsuario(self.datos, usuarioId)
                self.regUser.show()
                self.close()
                self.regUser.c.Back.connect(self.backMenu)
        else:
            QMessageBox.about(self, 'Alerta', 'No ha seleccionado ningun campo')


    def abrirSelecPac(self):
        self.pacienteId = self.filaSeleccionada()
        if self.pacienteId == '':
            QMessageBox.about(self, 'Alerta', 'No se ha seleccinado un paciente')
        self.c.Back.emit()

    def obtenerCampo(self):
        self.campoId = self.filaSeleccionada()
        if self.campoId == '':
            QMessageBox.about(self, 'Alerta', 'No se ha seleccinado un campo')
            return None
        else:
            return self.campoId, self.qenvia


    def backMenu(self):
        comando = "self." + self.ventanaAbierta + ".close()"
        eval(comando)
        self.c.Back.emit()

    def clickSelec(self):
        self.c.Selec.emit()

    def clickAtras(self, event):
        self.c.Back.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaSMUser()
    myapp.show()
    sys.exit(app.exec_())




