import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from terapias import Ui_frm_terapias
from AplicacionCodigo.Ventanas.VentanaIntervencion import VentanaIntervencion
from AplicacionCodigo.BaseDatos.ConectorBD import ConectorBD

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()

class VentanaTerapias(QtGui.QWidget):

    def __init__(self, Datos, DatosPac):
        super(VentanaTerapias, self).__init__()
        self.datosPac = DatosPac
        self.datos = Datos
        self.Nombre = Datos[0]
        self.Apellido = Datos[1]
        self.Rol = Datos[2]
        self.Foto = Datos[3]
        self.ui = Ui_frm_terapias()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.InfoUsr()
        self.InfoPac()
        self.modificarBotones()
        self.conexiones()
        self.conector = ConectorBD()
        self.c = Communicate()


    def InfoUsr(self):
        self.ui.lbl_descUsr.setText(self.Nombre + ' ' + self.Apellido + '\n' + self.Rol)
        foto = open('../AplicacionCodigo/Estatico/UsuarioActual.jpg','wb')
        foto.write(self.Foto)
        foto.close()
        self.ui.lbl_fotoUsr.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/UsuarioActual.jpg"))

    def InfoPac(self):
        self.ui.lbl_descPac.setText(self.datosPac[1] + ' ' + self.datosPac[3] + '\n' + 'Paciente')
        foto = open('../AplicacionCodigo/Estatico/PacienteActual.jpg', 'wb')
        foto.write(self.datosPac[10])
        foto.close()
        self.ui.lbl_fotoPac.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/PacienteActual.jpg"))

    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_VentanaTerapiasE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_Lenguaje.setStyleSheet("background-color: rgb(153, 255, 102)")
        self.ui.btn_Pragmatica.setStyleSheet("background-color: rgb(102, 179, 255)")
        self.ui.btn_Articulacion.setStyleSheet("background-color: rgb(255, 179, 102)")
        self.ui.btn_OralMotora.setStyleSheet("background-color: rgb(150, 179, 102)")
        if self.datos[2] == 'SuperUsuario':
            self.ui.btnl_Salir.setPixmap(QtGui.QPixmap("../AplicacionCodigo/Estatico/iconoAtras.png"))


    def conexiones(self):
        self.ui.btnl_Salir.mousePressEvent = self.clickSalir
        self.ui.btn_Lenguaje.clicked.connect(self.abrirIntervencion)

    def abrirIntervencion(self):
        self.ventanaAbierta = 'Intervencion'
        self.Intervencion = VentanaIntervencion(self.datos, self.datosPac)
        self.Intervencion.show()
        self.close()
        self.Intervencion.c.Back.connect(self.backMenu)

    def backMenu(self):
        self.show()
        eval('self.' + self.ventanaAbierta + '.close()')

    def clickSalir(self, event):
        self.c.Back.emit()



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = VentanaTerapias()
    myapp.show()
    sys.exit(app.exec_())




