import sys
import subprocess, signal
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from wireless import Ui_frm_wifi
from AplicacionCodigo.Ventanas.VentanaMetodosIngreso import VentanaMetodosIngreso


from AplicacionCodigo.BaseDatos.ConectorBD import *

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()


class VentanaWifi(QtGui.QWidget):

    def __init__(self):
        super(VentanaWifi, self).__init__()

        #Iniciar Interfaz Grafica
        self.ui = Ui_frm_wifi()
        self.ui.setupUi(self)
        self.ponerFondo()
        self.modificarBotones()
        self.conexiones()
        self.mI = VentanaMetodosIngreso()
        self.c = Communicate()


    def ponerFondo(self):
        palette = QPalette()
        bkg = QPixmap("Estatico/bkg_loginE.jpg")
        palette.setBrush(QPalette.Background, QBrush(bkg.scaled(QtGui.QWidget.size(self), QtCore.Qt.IgnoreAspectRatio)))
        QtGui.QWidget.setPalette(self, palette)
        QtGui.QWidget.setWindowFlags(self, QtCore.Qt.FramelessWindowHint)

    def modificarBotones(self):
        self.ui.btn_conectar.setStyleSheet("background-color: rgb(230, 255, 204)")


    def conexiones(self):
        self.ui.btn_conectar.clicked.connect(self.clickAtras)

    def abrirVentana(self):
        self.proc1 = subprocess.Popen(['sudo', 'wicd-client', '&'])
        print "wicd: " + str(self.proc1.pid)
        self.proc2 = subprocess.Popen(['florence', '--use-config', 'Ventanas/florence.conf', '&'])
        print "florence: " + str(self.proc2.pid)


    def cerrarVentanas(self):
        self.proc1.terminate()
        self.proc2.terminate()
        #self.proc1.send_signal(signal.SIGINT)
        #subprocess.check_output("kill -9 " + str(self.proc2.pid), shell=True)


    def clickAtras(self, event):
        self.cerrarVentanas()
        self.c.Back.emit()


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    login = VentanaWifi()
    login.show()
    sys.exit(app.exec_())


