# -*- coding: utf-8 -*-

import pygame
import subprocess, signal
import sys
import time
import threading
from AplicacionCodigo.Servidor.CamaraUbuntu import *
#from AplicacionCodigo.Servidor.CamaraRaspberry import *
from AplicacionCodigo.Servidor.tts import TTS
import speech_recognition as sr
import urllib
import re
from bs4 import BeautifulSoup


class modoAutonomo():
    def __init__(self):
        self.leer = TTS()
        self.c =Camara(0)
        #self.c = Camara()
        self.d = DeteccionFacial(cascade_fn="Servidor/haarcascade_frontalface_alt2.xml")

    def iniciar(self):
        self.hilo = threading.Thread(target=self.modoPasivo, name="hilo")
        self.hilo.start()

        #while True:
        #    self.modoPasivo()
        #    self.modoInteraccion()
        #    if self.paro == True:
        #        self.c = None
        #        break

    def modoPasivo(self):
        time.sleep(0.1)
        self.paro = False
        while True:
            if self.paro == True:
                self.c = None
                break
            captura = self.c.capturarImagen()
            img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
            ncaras = self.d.numeroCaras(img)
            if ncaras > 0:
                self.leer.hablar('Hola, me llamo speltra')
                self.c = None
                self.modoInteraccion()



    def modoInteraccion(self):
        self.escuchaPasiva()

    def mantenerContacto(self):
        contadorDondeEstas = 0
        contadorCero = 0
        while True:
            captura = self.c.capturarImagen()
            img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
            ncaras = self.d.numeroCaras(img)
            if ncaras < 1:
                acaras = []
                for i in range(1, 30):
                    captura = self.c.capturarImagen()
                    img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
                    ncaras = self.d.numeroCaras(img)
                    acaras.append(ncaras)
                if all(i == 0 for i in acaras):
                    contadorCero += 1
                    if contadorCero > 3:
                        contadorDondeEstas += 1
                        self.leer.hablar('Dónde estás')
                        self.salirEscuchaPasiva = True
                        contadorCero = 0
                    if contadorDondeEstas >= 3:
                        break
                else:
                    contadorCero = 0
                    contadorDondeEstas = 0
            if self.paro == True:
                self.salirEscuchaPasiva = True
                break
        self.leer.hablar('Cháo')

    def escuchaPasiva(self):
        self.r = sr.Recognizer()
        while True:
            if self.paro == True:
                self.c = None
                break
            self.leer.hablar('Estoy listo para escucharte')
            source = None
            #time.sleep(1)
            with sr.Microphone() as source:
                audio = self.r.listen(source)
            try:
                self.resp = self.r.recognize_google(audio, key="AIzaSyCCdRD5mlqDBInH2q_CtXjLn-F2iA-yskA", language="es-EC")
                print self.resp
                if self.resp == 'Hola':
                    self.leer.hablar('Un gusto, puedo ayudárte en álgo')
                    break
                else:
                    self.leer.hablar('Te escuché, pero no te entiendo')
            except sr.WaitTimeoutError:
                print 'se agoto el tiempo'
                self.leer.hablar('No has dicho nada en un buen tiempo')
            except sr.UnknownValueError:
                print 'no te entiendo'
                self.leer.hablar('No te pude escuchar')
            except sr.RequestError as e:
                print 'no se conecto'
                self.leer.hablar('Por el momento no puedo entenderte, necesito internet')
            except sr.URLError as e:
                print 'no se conecto'
                self.leer.hablar('Por el momento no puedo entenderte, necesito internet')
        #self.manejoComando()

    def manejoComando(self):
        contadorIntentos = 0
        while True:
            comando = self.escuchaActiva()
            if comando != None:
                if comando == 'Buscar':
                    self.leer.hablar('Qué palabra deseas que búsque')
                    break
                else:
                    self.leer.hablar('No conozco ese comando, intentalo de nuevo')
                    contadorIntentos += 1
            else:
                self.leer.hablar('Intentalo de nuevo')
                contadorIntentos += 1
            if contadorIntentos >= 3:
                self.leer.hablar('Existe algún problema , intentalo en otro momento')
                contadorIntentos = 0
                break




    def escuchaActiva(self):
        self.leer.hablar('Di algún comando')
        with sr.Microphone() as source:
            audio = self.r.listen(source)
        try:
            self.resp = self.r.recognize_google(audio, key="AIzaSyCCdRD5mlqDBInH2q_CtXjLn-F2iA-yskA", language="es-EC")
            print self.resp
            return self.resp
        except sr.WaitTimeoutError:
            print 'se agoto el tiempo'
            self.leer.hablar('No has dicho nada en un buen tiempo')
        except sr.UnknownValueError:
            print 'no te entiendo'
            self.leer.hablar('No te pude escuchar')
        except sr.RequestError as e:
            print 'no se conecto'
            self.leer.hablar('Por el momento no puedo entenderte, necesito internet')
        except sr.URLError as e:
            print 'no se conecto'
            self.leer.hablar('Por el momento no puedo entenderte, necesito internet')

