# -*- coding: utf-8 -*-

import speech_recognition as sr
import time
import urllib
import re
import pygame
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from bs4 import BeautifulSoup
from AplicacionCodigo.Servidor.tts import TTS
from AplicacionCodigo.Servidor.CamaraUbuntu import *

class Communicate(QtCore.QObject):
    Back = QtCore.pyqtSignal()
    Escribir = QtCore.pyqtSignal()

class modoAutonomo():
    def __init__(self):
        self.escribir = ''
        self.leer = TTS()
        self.r = sr.Recognizer()
        self.m = sr.Microphone()
        self.paro = False
        self.puedeSalir = True
        self.c = Communicate()
        self.d = DeteccionFacial(cascade_fn="Servidor/haarcascade_frontalface_alt2.xml")

    def iniciar(self):
        self.escuchaPasiva()

    def beepEscuchando(self):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/beepEscuchando.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
         continue

    def beepProcesando(self):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/beepProcesando.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
         continue

    def escuchar(self):
        try:
            with self.m as source:
                self.r.adjust_for_ambient_noise(source)
                audio = self.r.listen(source)
                if self.paro:
                    self.c.Back.emit()
                return audio
        except sr.WaitTimeoutError as e:
            self.leer.hablar('Lo siento, no pude escucharte, por favor repítelo')

    def reconocer(self, audio):
        try:
            #resp = self.r.recognize_google(audio, key="AIzaSyCCdRD5mlqDBInH2q_CtXjLn-F2iA-yskA", language="es-EC")
            resp = self.r.recognize_google(audio, language="es-EC")
            if resp == 'Adiós' or resp == 'adiós':
                self.paro = True
                self.c.Back.emit()
            return resp
        except sr.WaitTimeoutError:
            print 'se agoto el tiempo'
            self.leer.hablar('No has dicho nada en un buen tiempo')
        except sr.UnknownValueError:
            pass
        except sr.RequestError as e:
            print 'no se conecto'
            self.leer.hablar('Por el momento no puedo entenderte, necesito internet')
        except Exception:
            print 'no se conecto1'
            self.leer.hablar('Por el momento no puedo entenderte, necesito internet')

    def procesarSaludo(self, respuesta):
        if respuesta != None:
                #if respuesta == 'spell trap' or respuesta == 'el tra' or respuesta == 'spell tra' or \
                #                respuesta == 'espelta' or respuesta == 'Spectra' or respuesta == 'Beltrán':
                if respuesta == 'Hola' or respuesta == 'hola':
                    self.leer.hablar('Hola, en que puedo ayudarte')
                    return True
                else:
                    return False

    def escuchaPasiva(self):
        while True:
            self.escribir = 'Di "Hola.." cuando me necesites...'
            self.c.Escribir.emit()
            if self.paro:
                self.leer.hablar('Chau')
                self.escribir = ' '
                self.c.Escribir.emit()
                break
            self.beepEscuchando()

            audio = self.escuchar()
            self.beepProcesando()
            respuesta = self.reconocer(audio)
            print respuesta
            saludo = self.procesarSaludo(respuesta)
            if saludo:
                self.escuchaActiva()

    def escuchaActiva(self):
        contadorIntentos = 0
        while True:
            self.escribir = 'Di un comando...'
            self.c.Escribir.emit()
            if self.paro:
                break
            self.beepEscuchando()
            audio = self.escuchar()
            self.beepProcesando()
            respuesta = self.reconocer(audio)
            print respuesta
            if respuesta != None:
                if respuesta == 'Buscar':
                    self.buscarPalabra()
                    #time.sleep(2)
                    #self.leer.hablar('Quedo disponible')
                    break
                elif respuesta == 'Salir' or respuesta == 'salir':
                    self.leer.hablar('Quedo disponible')
                    break
                elif respuesta == 'Adiós' or respuesta == 'adiós':
                    break
                else:
                    self.leer.hablar('No conozco ese comando')
                    contadorIntentos += 1
            if contadorIntentos == 3:
                self.leer.hablar('Lo siento, existe algún problema, intentalo en otro momento')
                time.sleep(2)
                self.leer.hablar('Quedo disponible')
                break

    def buscarPalabra(self):
        self.escribir = 'Di una palabra...'
        self.c.Escribir.emit()
        self.leer.hablar('Qué palabra deseas que busqué')
        for i in range(1, 4):
            if self.paro:
                break
            self.beepEscuchando()
            audio = self.escuchar()
            self.beepProcesando()
            respuesta = self.reconocer(audio)
            print respuesta
            if respuesta != None:
                if respuesta == 'Salir' or respuesta == 'salir':
                    break
                elif respuesta == 'Adiós' or respuesta == 'adiós':
                    break
                self.leer.hablar('Acaso dijiste: ' + respuesta)
                confir = self.confirmacion()
                if confir:
                    self.leer.hablar('La palabra que voy a buscar es:' + respuesta + ', espera un momento')
                    url = "https://es.wikipedia.org/wiki/"+str(respuesta.replace(" ","_").lower())
                    html = urllib.urlopen(url).read()
                    soup = BeautifulSoup(html)
                    result = soup.p.get_text()
                    Imprimir= re.sub("\[.*?\]", "", result)
                    self.leer.hablar(Imprimir)
                    break
            else:
                self.leer.hablar('No te pude entender')

    def confirmacion(self):
        self.escribir = 'Confirme si la palabra es correcta...'
        self.c.Escribir.emit()
        self.beepEscuchando()
        audio = self.escuchar()
        self.beepProcesando()
        respuesta = self.reconocer(audio)
        print respuesta
        if respuesta == 'Sí' or respuesta == 'sí':
            return True
        elif respuesta == 'No' or respuesta == 'no':
            self.leer.hablar('Perdón, puédes repetir la palabrá')
            return False
        else:
            self.leer.hablar('No te puede entender, repite la palabra')

    def modoPasivo(self):
        self.paro = False
        self.c = Camara(0)
        while True:
            if self.paro == True:
                self.c = None
                break
            captura = self.c.capturarImagen()
            img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
            ncaras = self.d.numeroCaras(img)
            if ncaras > 0:
                self.leer.hablar('Hola, me llamo speltra')

