# -*- coding: utf-8 -*-

import speech_recognition as sr
import time
import urllib
import re
import pygame
from bs4 import BeautifulSoup
from AplicacionCodigo.Servidor.tts import TTS
from AplicacionCodigo.Servidor.CamaraUbuntu import *



class modoAutonomo():
    def __init__(self):
        self.leer = TTS()
        self.r = sr.Recognizer()
        self.m = sr.Microphone()
        self.respuesta = None
        self.paro = False
        self.comandoBuscar = False
        self.procesando = False
        self.d = DeteccionFacial(cascade_fn="Servidor/haarcascade_frontalface_alt2.xml")

    def callback(self, recognizer, audio):
        if self.procesando == False:
            respuesta = None
            try:
                self.beepProcesando()
                respuesta = recognizer.recognize_google(audio, language="es-EC")
                print respuesta
                #self.stop_listening()
                print 'Entro a procesar respuesta'
                self.m = None
                self.procesarRespuesta(respuesta)
                self.m = sr.Microphone
                print 'Salio de procesar respuesta'
                self.beepEscuchando()
                audio = None
            except sr.UnknownValueError:
                respuesta = None
                pass
            except sr.RequestError as e:
                respuesta = None
                print("No se puede obtener los resultados del servicio de Google; {0}".format(e))
        else:
            print 'Esta procesando, no entro en callback'

    def procesarRespuesta(self, respuesta):
        if self.comandoBuscar:
            self.comandoBuscar = False
            if respuesta == 'Hola':
                self.leer.hablar('dijo hola dentro del comando buscar')
            self.comandoBuscar = False
        else:
            if respuesta == 'Hola':
                self.comandoBuscar = True
                self.leer.hablar('Entro en comando buscar diciendo hola')

    def iniciar(self):
        self.escuchaPasiva()

    def beepEscuchando(self):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/beepEscuchando.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
         continue

    def beepProcesando(self):
        pygame.mixer.init()
        pygame.mixer.music.load('../AplicacionCodigo/Biblioteca/AUDIO/beepProcesando.mp3')
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
         continue

    def escuchaPasiva(self):
        with self.m as source:
                self.r.adjust_for_ambient_noise(source)
        self.stop_listening = self.r.listen_in_background(self.m, self.callback)

    def reconocer(self, audio):
        try:
            resp = self.r.recognize_google(audio, key="AIzaSyCCdRD5mlqDBInH2q_CtXjLn-F2iA-yskA", language="es-EC")
            #resp = self.r.recognize_google(audio, language="es-EC")
            return resp
        except sr.WaitTimeoutError:
            print 'se agoto el tiempo'
            self.leer.hablar('No has dicho nada en un buen tiempo')
        except sr.UnknownValueError:
            pass
        except sr.RequestError as e:
            print e
            print 'no se conecto'
            self.leer.hablar('Por el momento no puedo entenderte, necesito internet')
        except Exception:
            print 'no se conecto1'
            self.leer.hablar('Por el momento no puedo entenderte, necesito internet')

    def escuchaActiva(self):
        contadorIntentos = 0
        i = 0
        while True:
            i += 1
            self.beepEscuchando()
            with self.m as source:
                self.r.adjust_for_ambient_noise(source)
                audio = self.r.listen(source)
                self.beepProcesando()
                respuesta = self.reconocer(audio)
                print respuesta
                print 'Intento ' + str(i)
            if respuesta != None:
                if respuesta == 'Buscar':
                    self.buscarPalabra()
                    break
                elif respuesta == 'Salir' or respuesta == 'salir':
                    break
                else:
                    self.leer.hablar('No conozco ese comando')
            else:
                contadorIntentos += 1
            if contadorIntentos == 3:
                self.leer.hablar('Lo siento, existe algún problema, intento en otro momento')
                break

    def buscarPalabra(self):
        self.leer.hablar('Qué palabra deseas que busqué')
        for i in range(1, 4):
            if self.paro:
                break
            self.beepEscuchando()
            with self.m as source:
                self.r.adjust_for_ambient_noise(source)
                audio = self.r.listen(source)
                self.beepProcesando()
                respuesta = self.reconocer(audio)
                print respuesta
            if respuesta != None:
                if respuesta == 'Salir' or respuesta == 'salir':
                    break
                self.leer.hablar('Acaso dijiste: ' + respuesta)
                confir = self.confirmacion()
                if confir:
                    self.leer.hablar('La palabra que voy a buscar es:' + respuesta + ', espera un momento')
                    url = "https://es.wikipedia.org/wiki/"+str(respuesta.replace(" ","_").lower())
                    html = urllib.urlopen(url).read()
                    soup = BeautifulSoup(html)
                    result = soup.p.get_text()
                    Imprimir= re.sub("\[.*?\]","",result)
                    self.leer.hablar(Imprimir)
                    break
            else:
                self.leer.hablar('No te pude entender')

    def confirmacion(self):
        self.beepEscuchando()
        with self.m as source:
            self.r.adjust_for_ambient_noise(source)
            audio = self.r.listen(source)
            self.beepProcesando()
            respuesta = self.reconocer(audio)
            print respuesta
        if respuesta == 'Sí' or respuesta == 'sí':
            return True
        elif respuesta == 'No' or respuesta == 'no':
            self.leer.hablar('Perdón, puédes repetir la palabrá')
            return False
        else:
            self.leer.hablar('No te puede entender, repite la palabra')

    def modoPasivo(self):
        self.paro = False
        self.c = Camara(0)
        while True:
            if self.paro == True:
                self.c = None
                break
            captura = self.c.capturarImagen()
            img = cv2.resize(captura, (captura.shape[1] / 2, captura.shape[0] / 2), interpolation=cv2.INTER_CUBIC)
            ncaras = self.d.numeroCaras(img)
            if ncaras > 0:
                self.leer.hablar('Hola, me llamo speltra')

    def escuchaBackground(self):
        with self.m as source:
            self.r.adjust_for_ambient_noise(source)
        self.stop_listening = self.r.listen_in_background(self.m, self.callback) ##Cuando llame a stop_listening() va a parar de escuchar en background


if __name__ == '__main__':
    import time

    ma = modoAutonomo()
    ma.iniciar()
    i = 0
    while True:
        i += 1
        print str(i)
        time.sleep(0.1)
